
/*************************************************************************************

NORSE WARS 7.1 (With superbonus)

Random Map Script by Matei of Woad Creations ~ www.woadcreations.nl
Last edit: NW_Mike

(Edited for balance from 5.1 by NW_Mike)
(Edited for the X-Pac and added atlanteans by NW_Mike)
(Edited for 6.1 MINIMAL favor trickle in center -- by Ko_in_DK)
(Edited for NW 6.2 by NW_Mike)
(Edited for 6.2 A > D  by mythod_PS2MAN)
(Edited for NW 6.3 by NW_Mike)
(Edited for NW 6.3.1 by NW_Mike)
(Edited for NW 6.3.2 by mythod_PS2MAN)
(Edited for NW 6.4 by mythod_PS2MAN)
(Edited for NW 6.4.3 by Phoenix_PS2MAN)

(Edited for NW 7.0 by NW_Mike)
(Edited for NW 7.1 by NW_Mike)


This script uses a lot of advanced features to create a randomly generated blood-style map with buyable units, technologies and god powers using favor from kills. Players start in small bases around a circular arena with a Healing Spring in the middle and must battle for the favor of the gods to get soldiers or buy myth units, upgrades and god powers. The three major gods get different bonuses, and each game, there are many paths to victory - you must choose wisely what strategy you will use to dominate your opponents.

Version 6.0 adds the following new features:
- Two new environments: Tundra and Marsh, with the new terrains and units in The Titans expansion pack.
- New Large Map Mode: on Large size maps, the center of the map is a large maze with many forests. There are multiple Healing Springs, which grant a steady trickle of favor to the player who controls them. Furthermore, players can build Towers (50 favor) and Sky Passages (40 favor). The game plays out more like a Supremacy game with raiding, map control, and scouting, leading to large, epic battles.
- Limited each god power to only one use at a time, to prevent some of the bugs that were happening with powers like Flaming Weapons.
- Removed Restoration. You can now repair your Hill Fort with Norse infantry by just rightclicking it. This costs favor from your stockpile.
- New god powers: Implode, Spider Lair, Carnivora, Plague of Serpents, and more. On each map there are now 2 random environment-based powers.
- New rewards for kills, to add new strategies and choices. When you reach 100, 300, 600 and 1000 kills, you recieve a choice of 3 rewards on a small island at the bottom of the map. These are major rewards and they get bigger as you gain more kills. The choices include +50% Myth Unit Speed, Super Hersirs, Omniscience, a mighty Titan, and more.
- New maximum caps and ramping costs on the upgrades.
- Many balance changes.


RULES:

- Every player controls a Hill Fort, and they lose if it is destroyed
- Players are all Norse and get favor when their human units fight
- Human units spawn for each player at their Hill Fort. The player can choose between Archers, Infantry or Cavalry using the Flag Bearer on his island. The more favor a player has, the better the units he gets become.
- Favor may be paid on the store island behind players' bases to:
  - Buy a god power (available powers depend on the map)
  - Upgrade weapons, armor or shields (the price increases each time you buy upgrade, and the maximum cap is 7 of each)
  - Buy a myth unit or hero (available units depend on the map)
  - Buy your god's unique unit
- Favor may also be used to repair your Hill Fort; just task a Norse infantry to it by rightclicking.
- When you reach 100, 300, 600 and 1000 kills, you recieve a choice of 3 rewards on a small island at the bottom of the map.
- Every 3 minutes, players recieve Reinforcements (units and a bonus) based on god choice, and every 4 minutes, the center is Meteored
- On Large maps, the following changes are present:
  - The center of the map is a maze of forests containing several Healing Springs (one between every two players and one in the center).
  - Each Healing Spring you control gives you 10 free favor per minute
  - Players may use infantry to build Towers for 50 favor, or Houses, which are converted to Sky Passages, for 40 favor.
  - Upgrades cost more and have a higher cap, and Hill Forts are more powerful.


FEATURES:

- Very fast download time due to small file size
- Supports anywhere from 2 to 12 players
- Six random skins: Greek, Egyptian, Norse, Underworld, Tundra and Marsh with different terrains, random buyable god powers and random buyable units based on thos environments
- Many strategies for victory: will you hoard favor to get more auto-spawning soldiers, buy weapons/armor to upgrade your troops, field an army of myth units, control the Healing Spring in the center, or make use of god powers to defeat your opponents?
- Unique civilization bonuses and units make the three major gods balanced yet radically different
- Random fast-paced battle music to keep you on your toes
- Every map generated is different and requires players to adapt
- Countless hours of fast-paced fun! There will be swords clanging, arrows whizzing, monsters roaring and units flying through the air from the first minute onward.


HOW TO HOST A GAME:

- Norse Wars should be played mutiplayer with human players, as computer players don't know how to use favor to buy things.
- Host a game using ESO Advanced Setup or LAN/DirectIP.
- Select Supremacy under Game Type.
- Click Select Map and choose Norse Wars 6.0 from the list.
- Choose either Normal size or Large size (Normal is for free-for-all's and shorter, faster games; Large is great for intense team battles and big struggles for control).
- All players must be Norse to get favor from fighting.
- If you want to play in the Norse Wars Ladder, you can sign up and report games at www.NorseWars.com.


TO OTHER SCRIPTERS:

- You are free to use this script or parts of it in your own work, but PLEASE GIVE CREDIT TO THE ORIGINAL AUTHOR (MATEI) IF YOU DO SO! Use a script comment and an in-game text message.
- If you want to edit the map, PLEASE DO NOT MODIFY THIS FILE. Copy the file and rename it, so that there aren't any file name conflicts with people who don't have your edited version.
- If you have any questions about the map, post them in the Woad Creations forums at www.woadcreations.com.


ACKNOWLEDGEMENTS:

I would like to thank the following people:
- The members of Woad Creations, especially Shiva and Yhagoro, for their playtesting and their excellent advice on all aspects of the map
- The NW and Phoenix clans, for organizing www.NorseWars.com (the NW ladder and forums)
- The VinaCIS clan, for some of the balance suggestions for Norse Wars
- The makers of SCNPunk's Troy Massacre, where I got the random battle music idea from (Troy Massacre is really a blast to play!)
- Wolfenhex, for the trigonometry functions in his map, "The Void"
- TwentyOneScore, for his posts on using custom triggers in RM scripts
- And last but not least, all the Norse Wars fans on ESO. It's great to see that people enjoy playing this map as much as I enjoyed making it :)


*************************************************************************************/


// Tech ID constants

int cTechAge1=0;
int cTechAge2=1;
int cTechAge3=2;
int cTechMediumArchers=3;
int cTechHeavyArchers=4;
int cTechChampionArchers=5;
int cTechMediumInfantry=6;
int cTechHeavyInfantry=7;
int cTechChampionInfantry=8;
int cTechHusbandry=9;
int cTechPlow=10;
int cTechIrrigation=11;
int cTechCopperWeapons=12;
int cTechBronzeWeapons=13;
int cTechIronWeapons=14;
int cTechCopperMail=15;
int cTechBronzeMail=16;
int cTechIronMail=17;
int cTechCopperShields=18;
int cTechBronzeShields=19;
int cTechIronShields=20;
int cTechAmbassadors=21;
int cTechTaxCollectors=22;
int cTechCoinage=23;
int cTechMediumCavalry=24;
int cTechHeavyCavalry=25;
int cTechChampionCavalry=26;
int cTechWatchTower=27;
int cTechGuardTower=28;
int cTechBallistaTower=29;
int cTechBoilingOil=30;
int cTechLevyInfantry=31;
int cTechBurningPitch=32;
int cTechMasons=33;
int cTechPickaxe=34;
int cTechHandAxe=35;
int cTechShaftMine=36;
int cTechBowSaw=37;
int cTechQuarry=38;
int cTechCarpenters=39;
int cTechBravery=40;
int cTechValleyoftheKings=41;
int cTechLightningStorm=42;
int cTechLocustSwarm=43;
int cTechTornado=44;
int cTechWinterHarvest=45;
int cTechSafeguard=46;
int cTechRampage=47;
int cTechMithrilBreastplate=48;
int cTechCallOfValhalla=49;
int cTechArcticWinds=50;
int cTechArcticGale=51;
int cTechWrathOfTheDeep=52;
int cTechSpiritedCharge=53;
int cTechThunderingHooves=54;
int cTechBerserkergang=55;
int cTechRime=56;
int cTechFrost=57;
int cTechDraftHorses=58;
int cTechEngineers=59;
int cTechArchitects=60;
int cTechMeteor=61;
int cTechBoneBow=62;
int cTechAxeofVengeance=63;
int cTechDesertWind=64;
int cTechEnclosedDeck=65;
int cTechCladding=66;
int cTechFortifiedWall=67;
int cTechAge1Zeus=68;
int cTechSkinOfTheRhino=69;
int cTechAge15Egyptian=70;
int cTechSacredCats=71;
int cTechGraniteBlood=72;
int cTechHamarrtroll=73;
int cTechCriosphinx=74;
int cTechHieracosphinx=75;
int cTechMonstrousRage=76;
int cTechPhobosSpearofPanic=77;
int cTechBacchanalia=78;
int cTechSunRay=79;
int cTechSylvanLore=80;
int cTechForgeofOlympus=81;
int cTechAge1Hades=82;
int cTechAge1Poseidon=83;
int cTechCreateGold=84;
int cTechAge1Ra=85;
int cTechAge1Isis=86;
int cTechAge1Set=87;
int cTechAge1Odin=88;
int cTechAge1Thor=89;
int cTechAge1Loki=90;
int cTechAuroraBorealis=91;
int cTechAge2Athena=92;
int cTechAge2Ares=93;
int cTechAge2Hermes=94;
int cTechAge3Dionysos=95;
int cTechAge3Apollo=96;
int cTechAge3Aphrodite=97;
int cTechAge4Hera=98;
int cTechAge4Artemis=99;
int cTechAge4Hephaestus=100;
int cTechHuntingDogs=101;
int cTechHandofTalos=102;
int cTechSarissa=103;
int cTechAegisShield=104;
int cTechWingedMessenger=105;
int cTechAge2Anubis=106;
int cTechAge2Bast=107;
int cTechAge2Ptah=108;
int cTechAge3Hathor=109;
int cTechAge3Nephthys=110;
int cTechAge3Sekhmet=111;
int cTechAge4Thoth=112;
int cTechAge4Osiris=113;
int cTechAge4Horus=114;
int cTechFeetoftheJackal=115;
int cTechAge4=116;
int cTechAge2Forseti=117;
int cTechAge2Heimdall=118;
int cTechAge2Freyja=119;
int cTechAge3Skadi=120;
int cTechAge3Bragi=121;
int cTechAge3Njord=122;
int cTechAge4Hel=123;
int cTechAge4Baldr=124;
int cTechAge4Tyr=125;
int cTechSignalFires=126;
int cTechStoneWall=127;
int cTechShoulderofTalos=128;
int cTechSkeletonPower=129;
int cTechBookofThoth=130;
int cTechFaceoftheGorgon=131;
int cTechCitadelWall=132;
int cTechUnderworldPassage=133;
int cTechRestoration=134;
int cTechConscriptInfantry=135;
int cTechLevyArchers=136;
int cTechConscriptArchers=137;
int cTechLevyCavalry=138;
int cTechConscriptCavalry=139;
int cTechCarrierPigeons=140;
int cTechFloodControl=141;
int cTechPharaohRespawn=142;
int cTechStartingUnitsNorse=143;
int cTechStartingUnitsGreek=144;
int cTechStartingUnitsEgyptian=145;
int cTechGreatHunt=146;
int cTechCeaseFire=147;
int cTechMonument1=148;
int cTechMonument2=149;
int cTechMonument3=150;
int cTechMonument4=151;
int cTechUndermine=152;
int cTechDwarvenMail=153;
int cTechDwarvenShields=154;
int cTechDwarvenWeapons=155;
int cTechRain=156;
int cTechSerpentSpear=157;
int cTechFloodoftheNile=158;
int cTechVaultsofErebus=159;
int cTechLordofHorses=160;
int cTechOlympicParentage=161;
int cTechPigSticker=162;
int cTechLoneWanderer=163;
int cTechEyesintheForest=164;
int cTechScallopedAxe=165;
int cTechRingGiver=166;
int cTechLongSerpent=167;
int cTechSwineArray=168;
int cTechAge15Norse=169;
int cTechAge15Greek=170;
int cTechOdinsRavenRespawn=171;
int cTechSnowStorm=172;
int cTechHeavyCamelry=173;
int cTechChampionCamelry=174;
int cTechBronze=175;
int cTechPharaohRespawnOsiris=176;
int cTechNewKingdom=177;
int cTechMedjay=178;
int cTechFuneralRites=179;
int cTechSpiritofMaat=180;
int cTechCityoftheDead=181;
int cTechFortifyTownCenter=182;
int cTechHeroesZeusAge2=183;
int cTechHeroesZeusAge3=184;
int cTechHeroesZeusAge4=185;
int cTechHeroesPoseidonAge2=186;
int cTechHeroesPoseidonAge3=187;
int cTechHeroesPoseidonAge4=188;
int cTechHeroesHadesAge2=189;
int cTechHeroesHadesAge3=190;
int cTechHeroesHadesAge4=191;
int cTechShaduf=192;
int cTechMonument0=193;
int cTechRelicAnkhofRa=194;
int cTechRelicEyeofHorus=195;
int cTechRelicSistrumofBast=196;
int cTechRelicHeadofOrpheus=197;
int cTechRelicRingoftheNibelung=198;
int cTechRelicStaffofDionysus=199;
int cTechRelicFettersofFenrir=200;
int cTechRelicOdinsSpear=201;
int cTechRelicKitharaofApollo=202;
int cTechRelicMithrilHorseshoes=203;
int cTechRelicBowofArtemis=204;
int cTechRelicWedjatEye=205;
int cTechRelicNoseoftheSphinx=206;
int cTechGoldenApples=207;
int cTechEldhrimnirKettle=208;
int cTechRelicArrowsofAlfar=209;
int cTechRelicToothedArrows=210;
int cTechRelicWandofGambantein=211;
int cTechProsperity=212;
int cTechPegasusRelicRespawn=213;
int cTechRelicGoldenBridleofPegasus=214;
int cTechEclipse=215;
int cTechWillofKronos=216;
int cTechLabyrinthofMinos=217;
int cTechFlamesofTyphon=218;
int cTechDivineBlood=219;
int cTechShaftsofPlague=220;
int cTechVision=221;
int cTechBolt=222;
int cTechSpy=223;
int cTechFlamingWeapons=224;
int cTechFlamingWeaponsActive=225;
int cTechLossofLOS=226;
int cTechSerpents=227;
int cTechAnimalMagnetism=228;
int cTechHealingSpring=229;
int cTechCurse=230;
int cTechSentinel=231;
int cTechSandstorm=232;
int cTechCitadel=233;
int cTechWalkingWoods=234;
int cTechRagnorok=235;
int cTechNidhogg=236;
int cTechPlenty=237;
int cTechSonofOsiris=238;
int cTechPharaohRespawnCityoftheDead=239;
int cTechEarthquake=240;
int cTechAthenianWall=241;
int cTechHeroesHadesAge1=242;
int cTechHeroesPoseidonAge1=243;
int cTechHeroesZeusAge1=244;
int cTechDwarvenAuger=245;
int cTechPurseSeine=246;
int cTechReinforcedHull=247;
int cTechHuntressAxe=248;
int cTechForestFire=249;
int cTechPestilence=250;
int cTechRelicTriosBow=251;
int cTechRelicShardofBlueCrystal=252;
int cTechRelicArmorofAchilles=253;
int cTechRelicShipofFingernails=254;
int cTechCrocodopolis=255;
int cTechLeatherFrameShield=256;
int cTechElectrumBullets=257;
int cTechStonesofRedLinen=258;
int cTechSpearontheHorizon=259;
int cTechFeral=260;
int cTechAnastrophe=261;
int cTechTrierarch=262;
int cTechThracianHorses=263;
int cTechRelicShinglesofSteel=264;
int cTechRelicEyeofOrnlu=265;
int cTechRelicTuskoftheIronBoar=266;
int cTechAssignLOS=267;
int cTechRoarofOrthus=268;
int cTechAtefCrown=269;
int cTechConscriptSailors=270;
int cTechNavalOxybeles=271;
int cTechEnyosBowofHorror=272;
int cTechDeimosSwordofDread=273;
int cTechChampionElephants=274;
int cTechHallofThanes=275;
int cTechAdzeofWepwawet=276;
int cTechSlingsoftheSun=277;
int cTechRamoftheWestWind=278;
int cTechSundriedMudBrick=279;
int cTechFuneralBarge=280;
int cTechNecropolis=281;
int cTechDisableArmoryforThor=282;
int cTechIronMailThor=283;
int cTechBronzeMailThor=284;
int cTechBronzeShieldsThor=285;
int cTechBronzeWeaponsThor=286;
int cTechIronShieldsThor=287;
int cTechIronWeaponsThor=288;
int cTechBurningPitchThor=289;
int cTechHammeroftheGods=290;
int cTechMeteoricIronMail=291;
int cTechDragonscaleShields=292;
int cTechTusksofApedemak=293;
int cTechRelicPandorasBox=294;
int cTechRelicHerasThundercloudShawl=295;
int cTechRelicHarmoniasNecklace=296;
int cTechRelicDwarfenCalipers=297;
int cTechOracle=298;
int cTechSonsofSleipnir=299;
int cTechSetAge2Critter=300;
int cTechSetAge3Critter=301;
int cTechSetAge4Critter=302;
int cTechPoseidonHippocampusRespawn=303;
int cTechEgyptianbuildingbonus=304;
int cTechOmniscience=305;
int cTechMediumAxemen=306;
int cTechHeavyAxemen=307;
int cTechChampionAxemen=308;
int cTechMediumSpearmen=309;
int cTechHeavySpearmen=310;
int cTechChampionSpearmen=311;
int cTechHeavyChariots=312;
int cTechChampionChariots=313;
int cTechHeavyElephants=314;
int cTechLevyBarracksSoldiers=315;
int cTechConscriptBarracksSoldiers=316;
int cTechLevyMigdolSoldiers=317;
int cTechConscriptMigdolSoldiers=318;
int cTechMediumSlingers=319;
int cTechHeavySlingers=320;
int cTechChampionSlingers=321;
int cTechRelicGoldenLions=322;
int cTechRelicMonkeyHead=323;
int cTechLevyLonghouseSoldiers=324;
int cTechConscriptLonghouseSoldiers=325;
int cTechConscriptHillFortSoldiers=326;
int cTechLevyHillFortSoldiers=327;
int cTechThurisazRune=328;
int cTechGoldenLionsRelicRespawn=329;
int cTechMonkeyHeadRelicRespawn=330;
int cTechRelicCanopicJarofImsety=331;
int cTechRelicTowerofSestus=332;
int cTechRelicTrojanGateHinge=333;
int cTechSPCMeteor=334;
int cTechOdinsFirstRavens=335;
int cTechHeroesEgyptianAge1=336;
int cTechWeakenAge1Units=337;
int cTechSaltAmphora=338;
int cTechMediumMigdolShadow=339;
int cTechPoseidonFirstHippocampus=340;
int cTechTempleofHealing=341;
int cTechGreatestofFifty=342;
int cTechCopperMailThor=343;
int cTechCopperShieldsThor=344;
int cTechCopperWeaponsThor=345;
int cTechWeaponoftheTitans=346;
int cTechAge2Fake=347;
int cTechAge3Fake=348;
int cTechAge4Fake=349;
int cTechCrenellations=350;
int cTechBlessingofZeus=351;
int cTechRelicGirdleofHippolyta=352;
int cTechSharedLOS=353;
int cTechRelicPygmalionsStatue=354;
int cTechRelicBlackLotus=355;
int cTechDeathmatchGreek=356;
int cTechDeathmatchEgyptian=357;
int cTechDeathmatchNorse=358;
int cTechCeasefireEffect=359;
int cTechNorsebuildingbonus=360;
int cTechLightningMode=361;
int cTechFortifiedTents=362;
int cTechDwarvenShieldsEffect=363;
int cTechRelicHartersFolly=364;
int cTechRelicScarabPendant=365;
int cTechWellofUrd=366;
int cTechRelicBootsofKickEverything=367;
int cTechRelicAnvilofHephaestus=368;
int cTechRelicPeltofArgus=369;
int cTechRelicOsebergWagon=370;
int cTechRelicBuhenFlagstone=371;
int cTechRelicCatoblepasScales=372;
int cTechRelicTailofCerberus=373;
int cTechRelicBlanketofEmpressZoe=374;
int cTechRelicKhopeshofHorus=375;
int cTechCeaseFireNomad=376;
int cTechEclipseActive=377;
int cTechPlentyKOTHenable=378;
int cTechStartingUnitsThor=379;
int cTechSetAge1Critter=380;
int cTechStartingResourcesEgyptian=381;
int cTechStartingResourcesGreek=382;
int cTechStartingResourcesNorse=383;
int cTechRelicReedofNekhebet=384;
int cTechWeakenTrojanGate=385;
int cTechBuildTCfaster=386;
int cTechIncreaseRegeneration=387;
int cTechChickenStorm=388;
int cTechWalkingBerryBushes=389;
int cTechEliteHersir=390;
int cTechGoatunheim=391;
int cTechMythicRejuvenation = 432;
int cTechBiteOfTheShark = 435;
int cTechWeightlessMace = 449;
int cTechVolcanicForge = 460;
int cTechHephaestusRevenge = 417;
int cTechGemino = 440;
int cTechIoGuardian = 487;
int cTechAlluvialClay = 430;
int cTechHeroicRenewal = 433;

// Tech status constants

int cTechStatusUnobtainable=0;
int cTechStatusObtainable=1;
int cTechStatusAvailable=2;
int cTechStatusResearching=3;
int cTechStatusActive=4;
int cTechStatusPersistent=5;

// Unit stance constants

int cUnitStanceAggressive=0;
int cUnitStanceDefensive=1;
int cUnitStancePassive=2;

// Icons

string iconThor = "<icon=(16)(ui\ui god thor 64x64)>";
string iconOdin = "<icon=(16)(ui\ui god odin 64x64)>";
string iconLoki = "<icon=(16)(ui\ui god loki 64x64)>";
string iconFavor = "<icon=(32)(icons\icon resource favor)>";
string iconFavorFull = "<icon=(32)(icons\icon resource favor full)>";
string iconGold = "<icon=(32)(icons\icon resource gold)>";

string k="";

// Armies array

int vArmy1=0; int vArmy2=0; int vArmy3=0; int vArmy4=0;
int vArmy5=0; int vArmy6=0; int vArmy7=0; int vArmy8=0;
int vArmy9=0; int vArmy10=0; int vArmy11=0; int vArmy12=0;

int getArmy(int num=-1) {
	if(num==1) return(vArmy1); if(num==2) return(vArmy2);
	if(num==3) return(vArmy3); if(num==4) return(vArmy4);
	if(num==5) return(vArmy5); if(num==6) return(vArmy6);
	if(num==7) return(vArmy7); if(num==8) return(vArmy8);
	if(num==9) return(vArmy9); if(num==10) return(vArmy10);
	if(num==11) return(vArmy11); if(num==12) return(vArmy12);

	return(0);	// should never be reached
}

int setArmy(int num=-1, int val=0) {
if(num==1) vArmy1 = val; if(num==2) vArmy2 = val;
	if(num==3) vArmy3 = val; if(num==4) vArmy4 = val;
	if(num==5) vArmy5 = val; if(num==6) vArmy6 = val;
	if(num==7) vArmy7 = val; if(num==8) vArmy8 = val;
	if(num==9) vArmy9 = val; if(num==10) vArmy10 = val;
	if(num==11) vArmy11 = val; if(num==12) vArmy12 = val;

	return(0);	// should never be reached
}

// Homes array

string vHome1=""; string vHome2=""; string vHome3=""; string vHome4="";
string vHome5=""; string vHome6=""; string vHome7=""; string vHome8="";
string vHome9=""; string vHome10=""; string vHome11=""; string vHome12="";

string getHome(int num=-1) {
	if(num==1) return(vHome1); if(num==2) return(vHome2);
	if(num==3) return(vHome3); if(num==4) return(vHome4);
	if(num==5) return(vHome5); if(num==6) return(vHome6);
	if(num==7) return(vHome7); if(num==8) return(vHome8);
	if(num==9) return(vHome9); if(num==10) return(vHome10);
	if(num==11) return(vHome11); if(num==12) return(vHome12);

	return("");	// should never be reached
}

string setHome(int num=-1, string val="") {
if(num==1) vHome1 = val; if(num==2) vHome2 = val;
	if(num==3) vHome3 = val; if(num==4) vHome4 = val;
	if(num==5) vHome5 = val; if(num==6) vHome6 = val;
	if(num==7) vHome7 = val; if(num==8) vHome8 = val;
	if(num==9) vHome9 = val; if(num==10) vHome10 = val;
	if(num==11) vHome11 = val; if(num==12) vHome12 = val;

	return("");	// should never be reached
}


// Monuments array

string vMonument1=""; string vMonument2=""; string vMonument3=""; string vMonument4="";
string vMonument5=""; string vMonument6=""; string vMonument7=""; string vMonument8="";
string vMonument9=""; string vMonument10=""; string vMonument11=""; string vMonument12="";

string getMonument(int num=-1) {
	if(num==1) return(vMonument1); if(num==2) return(vMonument2);
	if(num==3) return(vMonument3); if(num==4) return(vMonument4);
	if(num==5) return(vMonument5); if(num==6) return(vMonument6);
	if(num==7) return(vMonument7); if(num==8) return(vMonument8);
	if(num==9) return(vMonument9); if(num==10) return(vMonument10);
	if(num==11) return(vMonument11); if(num==12) return(vMonument12);

	return("");	// should never be reached
}

string setMonument(int num=-1, string val="") {
if(num==1) vMonument1 = val; if(num==2) vMonument2 = val;
	if(num==3) vMonument3 = val; if(num==4) vMonument4 = val;
	if(num==5) vMonument5 = val; if(num==6) vMonument6 = val;
	if(num==7) vMonument7 = val; if(num==8) vMonument8 = val;
	if(num==9) vMonument9 = val; if(num==10) vMonument10 = val;
	if(num==11) vMonument11 = val; if(num==12) vMonument12 = val;

	return("");	// should never be reached
}

// Starts array

string vStart1=""; string vStart2=""; string vStart3=""; string vStart4="";
string vStart5=""; string vStart6=""; string vStart7=""; string vStart8="";
string vStart9=""; string vStart10=""; string vStart11=""; string vStart12="";

string getStart(int num=-1) {
	if(num==1) return(vStart1); if(num==2) return(vStart2);
	if(num==3) return(vStart3); if(num==4) return(vStart4);
	if(num==5) return(vStart5); if(num==6) return(vStart6);
	if(num==7) return(vStart7); if(num==8) return(vStart8);
	if(num==9) return(vStart9); if(num==10) return(vStart10);
	if(num==11) return(vStart11); if(num==12) return(vStart12);

	return("");	// should never be reached
}

string setStart(int num=-1, string val="") {
if(num==1) vStart1 = val; if(num==2) vStart2 = val;
	if(num==3) vStart3 = val; if(num==4) vStart4 = val;
	if(num==5) vStart5 = val; if(num==6) vStart6 = val;
	if(num==7) vStart7 = val; if(num==8) vStart8 = val;
	if(num==9) vStart9 = val; if(num==10) vStart10 = val;
	if(num==11) vStart11 = val; if(num==12) vStart12 = val;

	return("");	// should never be reached
}

// SpecialXs array

float vSpecialX1=0; float vSpecialX2=0; float vSpecialX3=0; float vSpecialX4=0;
float vSpecialX5=0; float vSpecialX6=0; float vSpecialX7=0; float vSpecialX8=0;
float vSpecialX9=0; float vSpecialX10=0; float vSpecialX11=0; float vSpecialX12=0;

float getSpecialX(int num=-1) {
	if(num==1) return(vSpecialX1); if(num==2) return(vSpecialX2);
	if(num==3) return(vSpecialX3); if(num==4) return(vSpecialX4);
	if(num==5) return(vSpecialX5); if(num==6) return(vSpecialX6);
	if(num==7) return(vSpecialX7); if(num==8) return(vSpecialX8);
	if(num==9) return(vSpecialX9); if(num==10) return(vSpecialX10);
	if(num==11) return(vSpecialX11); if(num==12) return(vSpecialX12);

	return(0);	// should never be reached
}

float setSpecialX(int num=-1, float val=0) {
if(num==1) vSpecialX1 = val; if(num==2) vSpecialX2 = val;
	if(num==3) vSpecialX3 = val; if(num==4) vSpecialX4 = val;
	if(num==5) vSpecialX5 = val; if(num==6) vSpecialX6 = val;
	if(num==7) vSpecialX7 = val; if(num==8) vSpecialX8 = val;
	if(num==9) vSpecialX9 = val; if(num==10) vSpecialX10 = val;
	if(num==11) vSpecialX11 = val; if(num==12) vSpecialX12 = val;

	return(0);	// should never be reached
}

// SpecialZs array

float vSpecialZ1=0; float vSpecialZ2=0; float vSpecialZ3=0; float vSpecialZ4=0;
float vSpecialZ5=0; float vSpecialZ6=0; float vSpecialZ7=0; float vSpecialZ8=0;
float vSpecialZ9=0; float vSpecialZ10=0; float vSpecialZ11=0; float vSpecialZ12=0;

float getSpecialZ(int num=-1) {
	if(num==1) return(vSpecialZ1); if(num==2) return(vSpecialZ2);
	if(num==3) return(vSpecialZ3); if(num==4) return(vSpecialZ4);
	if(num==5) return(vSpecialZ5); if(num==6) return(vSpecialZ6);
	if(num==7) return(vSpecialZ7); if(num==8) return(vSpecialZ8);
	if(num==9) return(vSpecialZ9); if(num==10) return(vSpecialZ10);
	if(num==11) return(vSpecialZ11); if(num==12) return(vSpecialZ12);

	return(0);	// should never be reached
}

float setSpecialZ(int num=-1, float val=0) {
if(num==1) vSpecialZ1 = val; if(num==2) vSpecialZ2 = val;
	if(num==3) vSpecialZ3 = val; if(num==4) vSpecialZ4 = val;
	if(num==5) vSpecialZ5 = val; if(num==6) vSpecialZ6 = val;
	if(num==7) vSpecialZ7 = val; if(num==8) vSpecialZ8 = val;
	if(num==9) vSpecialZ9 = val; if(num==10) vSpecialZ10 = val;
	if(num==11) vSpecialZ11 = val; if(num==12) vSpecialZ12 = val;

	return(0);	// should never be reached
}

// Choosers array

string vChooser1=""; string vChooser2=""; string vChooser3=""; string vChooser4="";
string vChooser5=""; string vChooser6=""; string vChooser7=""; string vChooser8="";
string vChooser9=""; string vChooser10=""; string vChooser11=""; string vChooser12="";

string getChooser(int num=-1) {
	if(num==1) return(vChooser1); if(num==2) return(vChooser2);
	if(num==3) return(vChooser3); if(num==4) return(vChooser4);
	if(num==5) return(vChooser5); if(num==6) return(vChooser6);
	if(num==7) return(vChooser7); if(num==8) return(vChooser8);
	if(num==9) return(vChooser9); if(num==10) return(vChooser10);
	if(num==11) return(vChooser11); if(num==12) return(vChooser12);

	return("");	// should never be reached
}

string setChooser(int num=-1, string val="") {
if(num==1) vChooser1 = val; if(num==2) vChooser2 = val;
	if(num==3) vChooser3 = val; if(num==4) vChooser4 = val;
	if(num==5) vChooser5 = val; if(num==6) vChooser6 = val;
	if(num==7) vChooser7 = val; if(num==8) vChooser8 = val;
	if(num==9) vChooser9 = val; if(num==10) vChooser10 = val;
	if(num==11) vChooser11 = val; if(num==12) vChooser12 = val;

	return("");	// should never be reached
}

// InfUnits array

string vInfUnit1=""; string vInfUnit2=""; string vInfUnit3=""; string vInfUnit4="";
string vInfUnit5=""; string vInfUnit6=""; string vInfUnit7=""; string vInfUnit8="";
string vInfUnit9=""; string vInfUnit10=""; string vInfUnit11=""; string vInfUnit12="";

string getInfUnit(int num=-1) {
	if(num==1) return(vInfUnit1); if(num==2) return(vInfUnit2);
	if(num==3) return(vInfUnit3); if(num==4) return(vInfUnit4);
	if(num==5) return(vInfUnit5); if(num==6) return(vInfUnit6);
	if(num==7) return(vInfUnit7); if(num==8) return(vInfUnit8);
	if(num==9) return(vInfUnit9); if(num==10) return(vInfUnit10);
	if(num==11) return(vInfUnit11); if(num==12) return(vInfUnit12);

	return("");	// should never be reached
}

string setInfUnit(int num=-1, string val="") {
if(num==1) vInfUnit1 = val; if(num==2) vInfUnit2 = val;
	if(num==3) vInfUnit3 = val; if(num==4) vInfUnit4 = val;
	if(num==5) vInfUnit5 = val; if(num==6) vInfUnit6 = val;
	if(num==7) vInfUnit7 = val; if(num==8) vInfUnit8 = val;
	if(num==9) vInfUnit9 = val; if(num==10) vInfUnit10 = val;
	if(num==11) vInfUnit11 = val; if(num==12) vInfUnit12 = val;

	return("");	// should never be reached
}

// ArcUnits array

string vArcUnit1=""; string vArcUnit2=""; string vArcUnit3=""; string vArcUnit4="";
string vArcUnit5=""; string vArcUnit6=""; string vArcUnit7=""; string vArcUnit8="";
string vArcUnit9=""; string vArcUnit10=""; string vArcUnit11=""; string vArcUnit12="";

string getArcUnit(int num=-1) {
	if(num==1) return(vArcUnit1); if(num==2) return(vArcUnit2);
	if(num==3) return(vArcUnit3); if(num==4) return(vArcUnit4);
	if(num==5) return(vArcUnit5); if(num==6) return(vArcUnit6);
	if(num==7) return(vArcUnit7); if(num==8) return(vArcUnit8);
	if(num==9) return(vArcUnit9); if(num==10) return(vArcUnit10);
	if(num==11) return(vArcUnit11); if(num==12) return(vArcUnit12);

	return("");	// should never be reached
}

string setArcUnit(int num=-1, string val="") {
if(num==1) vArcUnit1 = val; if(num==2) vArcUnit2 = val;
	if(num==3) vArcUnit3 = val; if(num==4) vArcUnit4 = val;
	if(num==5) vArcUnit5 = val; if(num==6) vArcUnit6 = val;
	if(num==7) vArcUnit7 = val; if(num==8) vArcUnit8 = val;
	if(num==9) vArcUnit9 = val; if(num==10) vArcUnit10 = val;
	if(num==11) vArcUnit11 = val; if(num==12) vArcUnit12 = val;

	return("");	// should never be reached
}

// CavUnits array

string vCavUnit1=""; string vCavUnit2=""; string vCavUnit3=""; string vCavUnit4="";
string vCavUnit5=""; string vCavUnit6=""; string vCavUnit7=""; string vCavUnit8="";
string vCavUnit9=""; string vCavUnit10=""; string vCavUnit11=""; string vCavUnit12="";

string getCavUnit(int num=-1) {
	if(num==1) return(vCavUnit1); if(num==2) return(vCavUnit2);
	if(num==3) return(vCavUnit3); if(num==4) return(vCavUnit4);
	if(num==5) return(vCavUnit5); if(num==6) return(vCavUnit6);
	if(num==7) return(vCavUnit7); if(num==8) return(vCavUnit8);
	if(num==9) return(vCavUnit9); if(num==10) return(vCavUnit10);
	if(num==11) return(vCavUnit11); if(num==12) return(vCavUnit12);

	return("");	// should never be reached
}

string setCavUnit(int num=-1, string val="") {
if(num==1) vCavUnit1 = val; if(num==2) vCavUnit2 = val;
	if(num==3) vCavUnit3 = val; if(num==4) vCavUnit4 = val;
	if(num==5) vCavUnit5 = val; if(num==6) vCavUnit6 = val;
	if(num==7) vCavUnit7 = val; if(num==8) vCavUnit8 = val;
	if(num==9) vCavUnit9 = val; if(num==10) vCavUnit10 = val;
	if(num==11) vCavUnit11 = val; if(num==12) vCavUnit12 = val;

	return("");	// should never be reached
}


// Bonus stuff
string bonusMonument = "";
string bonusChoice1 = "";
string bonusFlag = "";
string bonusChoice2 = "";
string bonusChoice3 = "";



// Environment stuff

int env = 0;

int NORSE_ENV = 1;
int EGYPTIAN_ENV = 2;
int GREEK_ENV = 3;
int HADES_ENV = 4;
int TUNDRA_ENV = 5;
int MARSH_ENV = 6;

int POP_LIMIT = 180;

int LURE_END_TIME = 140;

int NUM_MUSICS = 40;

int HILLFORT_RAMPUP = 50;
int HILLFORT_START = 350;

// SB
float SB_GP_MULT = 1;
float SB_SU_MULT = 1;
int SB_Rampup = 1;
int SB_maxup = 0;
int SB_FFH = 0;
int SB_LOS = 0;

int SEC_SPRING_WIN = 600;
int SPRING_FAVOR_INC = 300;



string tPlayer = "";
string tConn = "";
string tMiddle = "";
string tStar = "";
string tDecoPatch = "";
string tForest = "";
string tBlack = "";
string tCliff = "";
string tBlackPatch = "";
string tBlackPatch2 = "";
float fBaseHeight = 0.0;
string sLight = "";
string sSea = "";
string sDeco1 = "";
string sDeco2 = "";
string sBlackPatchDeco = "";
int iBlackPatchDecoAmount = 0;

string sMU2 = "";
int iMU2Cost = 0;
string sMU1 = "";
int iMU1Cost = 0;
string sHero = "";
int iHeroCost = 0;


string sPower1 = "";
string sPower1Caster = "";
int iPower1Cost = 0;
string sPower2 = "";
string sPower2Caster = "";
int iPower2Cost = 0;

string sFreeMU1 = "";
string sFreeMU2 = "";
string sFreeMU3 = "";
string sFreeMU4 = "";

string sInf1 = "Ulfsark";
string sInf2 = "Hypaspist";
string sInf3 = "Huskarl";
string sInf4 = "Myrmidon";

string sArc1 = "Throwing Axeman";
string sArc2 = "Slinger";
string sArc3 = "Toxotes";
string sArc4 = "Crossbowman";

string sCav1 = "Raiding Cavalry";
string sCav2 = "Prodromos";
string sCav3 = "Hippikon";
string sCav4 = "Jarl";

string nInf1 = "";
string nInf2 = "";
string nInf3 = "";
string nInf4 = "";

string nArc1 = "";
string nArc2 = "";
string nArc3 = "";
string nArc4 = "";

string nCav1 = "";
string nCav2 = "";
string nCav3 = "";
string nCav4 = "";

string nFreeMU1 = "";
string nFreeMU2 = "";
string nFreeMU3 = "";
string nFreeMU4 = "";

string nMU1 = "";
string nMU2 = "";
string nHero = "";

string nPower1 = "";
string nPower1Caster = "";
string nPower2 = "";
string nPower2Caster = "";

// Utility functions

float PI = 3.1415926535897932384626433832795;

float abs(float x = 0) {
	if(x<0) return(0.0-x);
	else return(x);
}

float pow(float x = 0,int p = 0) {
	float x2 = 1;
	float x4 = 1;
	float x8 = 1;
	float x16 = 1;
	float x32 = 1;
	float x64 = 1;

	if(p>=2) x2 = x*x;
	if(p>=4) x4 = x2*x2;
	if(p>=8) x8 = x4*x4;
	if(p>=16) x16 = x8*x8;
	if(p>=32) x32 = x16*x16;
	if(p>=64) x64 = x32*x32;

	float ret = 1;

	while(p>=64) {
		ret = ret * x64;
		p = p - 64;
	}
	if(p>=32) {
		ret = ret * x32;
		p = p - 32;
	}
	if(p>=16) {
		ret = ret * x16;
		p = p - 16;
	}
	if(p>=8) {
		ret = ret * x8;
		p = p - 8;
	}
	if(p>=4) {
		ret = ret * x4;
		p = p - 4;
	}
	if(p>=2) {
		ret = ret * x2;
		p = p - 2;
	}
	if(p>=1) {
		ret = ret * x;
		p = p - 1;
	}

	return (ret);
}

float atan(float n = 0) {
	float m = n;
	if(n > 1) m = 1.0 / n;
	if(n < -1) m = -1.0 / n;
	float r = m;
	for(i = 1; < 100) {
		int j = i * 2 + 1;
		float k = pow(m,j) / j;
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	if(n > 1 || n < -1) r = PI / 2.0 - r;
	if(n < -1) r = 0.0 - r;
	return (r);
}

float atan2(float z = 0,float x = 0) {
	if(x > 0) return (atan(z / x));
	if(x < 0) {
		if(z < 0) return (atan(z / x) - PI);
		if(z > 0) return (atan(z / x) + PI);
		return (PI);
	}
	if(z > 0) return (PI / 2.0);
	if(z < 0) return (0.0 - (PI / 2.0));
	return (0);
}

float factorial(float n = 0) {
	float r = 1;
	for(i = 2; <= n) {
		r = r * i;
	}
	return (r);
}

float cos(float n = 0) {
	float r = 1;
	for(i = 1; < 100) {
		int j = i * 2;
		float k = pow(n,j) / factorial(j);
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	return (r);
}

float sin(float n = 0) {
	float r = n;
	for(i = 1; < 100) {
		int j = i * 2 + 1;
		float k = pow(n,j) / factorial(j);
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	return (r);
}

int curGuid = 0;
int guid(void) {
	curGuid = curGuid + 1;
	return(curGuid);
}

int createArea(float x=0, float z=0, float size=0, int heightBlend=2, float coherence=1, int parentArea=-1) {
	int id = 0;
	if(parentArea>-1)
		id = rmCreateArea("area"+guid(), parentArea);
	else
		id = rmCreateArea("area"+guid());
	rmSetAreaHeightBlend(id, heightBlend);
	if(x>-1 && z>-1)
		rmSetAreaLocation(id, x, z);
	rmSetAreaSize(id, size, size);
	rmSetAreaCoherence(id, coherence);
	return (id);
}

int createAreaLine(float x1=0, float z1=0, float x2=0, float z2=0, float size=0, string terrain="", int height=-1, int heightBlend=2) {
	int id = createArea(x1, z1, size, heightBlend, 1);
	rmAddAreaInfluenceSegment(id, x1, z1, x2, z2);
	if(height!=-1)
		rmSetAreaBaseHeight(id, height);
	rmSetAreaTerrainType(id, terrain);
	return (id);
}

float offX(float x=0, float tiles=0) {
	return (rmXTilesToFraction(rmXFractionToTiles(x) + (abs(tiles))*(tiles/abs(tiles))));
}

float offZ(float z=0, float tiles=0) {
	return (rmZTilesToFraction(rmZFractionToTiles(z) + (abs(tiles))*(tiles/abs(tiles))));
}

string pointLoc(float fracX = 0, float fracZ = 0) {
	return(""+rmXFractionToMeters(fracX)+",0,"+rmZFractionToMeters(fracZ));
}

string playerLoc(int i=1) {
	return(pointLoc(rmPlayerLocXFraction(i), rmPlayerLocZFraction(i)));
}

string playerGatherLoc(int i=1) {
	float fx = 0;
	float fz = 0;
	if (SB_FFH == 0)
	{
		fx = (0.5 - rmXTilesToFraction(12))/0.5;
		fz = (0.5 - rmZTilesToFraction(12))/0.5;
	}
	else if (SB_FFH == 1)
	{
		fx = (0.5 - rmXTilesToFraction(55))/0.5;
		fz = (0.5 - rmZTilesToFraction(55))/0.5;
	}
	return(pointLoc((rmPlayerLocXFraction(i)-0.5)*fx+0.5,
			(rmPlayerLocZFraction(i)-0.5)*fz+0.5));
}

string playerSpawnLoc(int i=1) {

	float fx = 0;
	float fz = 0;
	if (SB_FFH == 0)
	{
		fx = (0.5 - rmXTilesToFraction(4))/0.5;
		fz = (0.5 - rmZTilesToFraction(4))/0.5;
	}
	else if (SB_FFH == 1)
	{
		fx = (0.5 - rmXTilesToFraction(45))/0.5;
		fz = (0.5 - rmZTilesToFraction(45))/0.5;
	}

	return(pointLoc((rmPlayerLocXFraction(i)-0.5)*fx+0.5,
				(rmPlayerLocZFraction(i)-0.5)*fz+0.5));

}

string playerIslandLoc(int i=1) {
	float fx = (0.5 + rmXTilesToFraction(36))/0.5;
	float fz = (0.5 + rmZTilesToFraction(36))/0.5;
	return(pointLoc((rmPlayerLocXFraction(i)-0.5)*fx+0.5,
			(rmPlayerLocZFraction(i)-0.5)*fz+0.5));
}

void newCustomEffect(string xs="") {
	rmAddTriggerEffect("SetIdleProcessing");
	 rmSetTriggerEffectParam("IdleProc", "true); "+xs+" trSetUnitIdleProcessing(true");
}

void newEffect(string str="") {
	rmAddTriggerEffect(str);
}

void effectParam(string name="", string val="") {
	rmSetTriggerEffectParam(name, val, false);
}

void effectParamInt(string name="", int val=0) {
	rmSetTriggerEffectParamInt(name, val, false);
}

void effectParamArmy(string name="", int p=0, int a=0) {
	rmSetTriggerEffectParamArmy(name, p, a, false);
}

void newCondition(string str="") {
	rmAddTriggerCondition(str);
}

void newCustomCondition(string xs="") {
	rmAddTriggerCondition("All Buildings Dead");
	 rmSetTriggerConditionParam("PlayerID", "0)!=-2 && "+xs+" && (1-1", false);
}

void condParam(string name="", string val="") {
	rmSetTriggerConditionParam(name, val, false);
}

void condParamArmy(string name="", int p=0, int a=0) {
	rmSetTriggerConditionParamArmy(name, p, a, false);
}

string coloredPlayerName(int i=0) {
	return( "<color={PlayerColor("+i+")}>"+rmGetPlayerName(i)+"</color>" );
}

void grantTech(int i=1, int tech=0) {
	newEffect("Set Tech Status");
	 effectParam("PlayerID", ""+i);
	 effectParam("TechID", ""+tech);
	 effectParam("Status", ""+cTechStatusActive);
}

void grantTechStr(int i=1, string tech="") {
	newEffect("Set Tech Status");
	 effectParam("PlayerID", ""+i);
	 effectParam("TechID", tech);
	 effectParam("Status", ""+cTechStatusActive);
}

void removeTech(int i=1, int tech=0) {
	newEffect("Set Tech Status");
	 effectParam("PlayerID", ""+i);
	 effectParam("TechID", ""+tech);
	 effectParam("Status", ""+cTechStatusUnobtainable);
}

void sendChat(string message="", int player=0) {
	string effect = "Send Spoofed Chat"; if(player==0) effect = "Send Chat";
	newEffect(effect);
	 effectParam("Message", message);
	 effectParam("PlayerID", ""+player);
}

void sendChatTo(int player=1, string message="") {
	newEffect("Send Chat To Player");
	 effectParam("Message", message);
	 effectParam("PlayerID", "0");
	 effectParam("ToPlayerID", ""+player);
}

void sendChats(string m1="", string m2="", string m3="", string m4="", string m5="", int player=0) {
	if(m1!="") sendChat(m1, player);
	if(m2!="") sendChat(m2, player);
	if(m3!="") sendChat(m3, player);
	if(m4!="") sendChat(m4, player);
	if(m5!="") sendChat(m5, player);
}

void sendChatsTo(int player=1, string m1="", string m2="", string m3="", string m4="", string m5="", string m6="", string m7="", string m8="") {
	if(m1!="") sendChatTo(player, m1);
	if(m2!="") sendChatTo(player, m2);
	if(m3!="") sendChatTo(player, m3);
	if(m4!="") sendChatTo(player, m4);
	if(m5!="") sendChatTo(player, m5);
	if(m6!="") sendChatTo(player, m6);
	if(m7!="") sendChatTo(player, m7);
	if(m8!="") sendChatTo(player, m8);
}

void modifyProtoUnitFor(int player=0, string unit="", int field=1, float delta=0.0) {
	newEffect("Modify Protounit");
	 effectParam("PlayerID", ""+player);
	 effectParam("ProtoUnit", unit);
	 effectParam("Field", ""+field);
	 effectParam("Delta", ""+delta);
}

void modifyProtoUnitForStr(int player=0, string unit="", int field=1, string delta="") {
	newEffect("Modify Protounit");
	 effectParam("PlayerID", ""+player);
	 effectParam("ProtoUnit", unit);
	 effectParam("Field", ""+field);
	 effectParam("Delta", delta);
}

void modifyProtoUnit(string unit="", int field=1, float delta=0.0) {
	for(i=1; <cNumberPlayers) {
		modifyProtoUnitFor(i, unit, field, delta);
	}
}

void modifyProtoUnitStr(string unit="", int field=1, string delta="") {
	for(i=1; <cNumberPlayers) {
		modifyProtoUnitForStr(i, unit, field, delta);
	}
}


void changeName(string unitId="", string newName="") {
	newEffect("Change Name");
	 effectParam("SrcObject", unitId);
	 effectParam("NewName", newName);
}

void changeNameTrigger(string unitId="", string newName="") {
	int id = rmCreateTrigger("changeName_"+guid());
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newEffect("Change Name");
	 effectParam("SrcObject", unitId);
	 effectParam("NewName", newName);
}

int lastRandChosen = 0;

string chooseRand2(string s1="", string s2="") {
	int r = rmRandInt(1,2);
	lastRandChosen = r;
	if(r==1) {return(s1);}
	else {return(s2);}
}

string chooseRand3(string s1="", string s2="", string s3="") {
	int r = rmRandInt(1,3);
	lastRandChosen = r;
	if(r==1) {return(s1);} else if(r==2) {return(s2);} else {return(s3);}
}

string chooseRand4(string s1="", string s2="", string s3="", string s4="") {
	int r = rmRandInt(1,4);
	lastRandChosen = r;
	return(chooseRand2(chooseRand2(s1,s2), chooseRand2(s3,s4)));
}


string chooseRand5(string s1="", string s2="", string s3="", string s4="", string s5="") {
	int r = rmRandInt(1,5);
	lastRandChosen = r;
	if(r==1) {return(s1);}
	else if(r==2) {return(s2);}
	else if(r==3) {return(s3);}
	else if(r==4) {return(s4);}
	else {return(s5);}
}


string chooseRand(string s1="", string s2="", string s3="", string s4="") {
	if((s4=="" && s3=="") && s2=="") return(s1);
	if(s4=="" && s3=="") return(chooseRand2(s1,s2));
	if(s4=="") return(chooseRand3(s1,s2,s3));
	else return(chooseRand4(s1,s2,s3,s4));
}


int matchRand(int v1=0, int v2=0, int v3=0, int v4=0) {
	if(lastRandChosen==1) return(v1);
	if(lastRandChosen==2) return(v2);
	if(lastRandChosen==3) return(v3);
	else return(v4);
}

// ***** COSTS FOR STUFF *****
int getCost(string thing="") {
	if(thing=="Serpents") return(8);
	if(thing=="vision") return(15);
	if(thing=="Audrey") return(8);
	if(thing=="Spiders") return(8);
	if(thing=="Tremor") return(9);
	if(thing=="Curse") return(13);
	if(thing=="Flaming Weapons") return(35);
	if(thing=="Skeleton Power") return(12);
	if(thing=="Bronze") return(25);
	if(thing=="Meteor") return(32);
	if(thing=="Tornado") return(27);
	if(thing=="Forest Fire") return(16);
	if(thing=="Archer Atlantean Hero") return(3);
	if(thing=="Lancer Hero") return(3);
	if(thing=="Royal Guard Hero") return(3);
	if(thing=="Swordsman Hero") return(3);
	if(thing=="Hero Greek Achilles") return(6);
	if(thing=="Hero Greek Atalanta") return(6);
	if(thing=="Hero Greek Hippolyta") return(6);
	if(thing=="Hero Greek Heracles") return(7);
	if(thing=="Hero Greek Odysseus") return(6);
	if(thing=="Hero Greek Jason") return(5);
	if(thing=="Hero Greek Chiron") return(6);
	if(thing=="Hero Greek Theseus") return(6);
	if(thing=="Hero Greek Perseus") return(7);
	if(thing=="Priest") return(2);
	if(thing=="Centaur") return(3);
	if(thing=="Wadjet") return(3);
	if(thing=="Sphinx") return(3);
	if(thing=="Troll") return(3);
	if(thing=="Minotaur") return(3);
	if(thing=="Automaton") return(3);
	if(thing=="Promethean") return(3);
	if(thing=="Valkyrie") return(4);
	if(thing=="Einheriar") return(5);
	if(thing=="Fenris Wolf") return(5);
	if(thing=="Colossus") return(10);
	if(thing=="Fire Giant") return(8);
	if(thing=="Mountain Giant") return(9);
	if(thing=="Frost Giant") return(9);
	if(thing=="Heka Gigantes") return(11);
	if(thing=="Cyclops") return(5);
	if(thing=="Scarab") return(8);
	if(thing=="Behemoth") return(8);
	if(thing=="Medusa") return(7);
	if(thing=="Mummy") return(7);
	if(thing=="Avenger") return(7);
	if(thing=="Chimera") return(7);
	if(thing=="Battle Boar") return(8);
	if(thing=="Medusa") return(7);
	if(thing=="Argus") return(7);
	return(1);
}

string realName(string thing="") {
	if(thing=="Female") return("Greta Forkbeard");
	if(thing=="Einheriar") return("Einherjar");
	if(thing=="Lancer") return("Contrarius");
	if(thing=="Royal Guard") return("Fanatic");
	if(thing=="Javelin Cavalry") return("Turma");
	if(thing=="Archer Atlantean") return("Arcus");
	if(thing=="Archer Atlantean Hero") return("Arcus Hero");
	if(thing=="Lancer Hero") return("Hero Contrarius");
	if(thing=="Swordsman Hero") return("Hero Murmillo");
	if(thing=="Archer Atlantean Hero") return("Hero Arcus");
	if(thing=="Swordsman") return("Murmillo");
	if(thing=="Maceman") return("Katapeltes");
	if(thing=="Crossbowman") return("Gastraphetes");
	if(thing=="Skeleton Power") return("Ancestors");
	if(thing=="Sandstorm") return("Shifting Sands");
	if(thing=="Hero Greek Achilles") return("Achilles");
	if(thing=="Hero Greek Atalanta") return("Atalanta");
	if(thing=="Hero Greek Hippolyta") return("Hippolyta");
	if(thing=="Hero Greek Heracles") return("Heracles");
	if(thing=="Hero Greek Odysseus") return("Odysseus");
	if(thing=="Hero Greek Chiron") return("Chiron");
	if(thing=="Hero Greek Jason") return("Jason");
	if(thing=="Hero Greek Theseus") return("Theseus");
	if(thing=="Hero Greek Perseus") return("Perseus");
	if(thing=="Kastor Adult") return("Kastor");
	if(thing=="Ajax Older") return("Ajax");
	if(thing=="Amanra Older") return("Queen Amanra");
	if(thing=="Audrey") return("Carnivora");
	if(thing=="Serpents") return("Plague Of Serpents");
	if(thing=="Spiders") return("Spider Lair");
	if(thing=="Tremor") return("Shockwave");
	if(thing=="Shade of Hades") return("Shade");
	if(thing=="Caravan Atlantean") return("Llama Caravan");
	if(thing=="Caravan Greek") return("Donkey Caravan");
	if(thing=="Caravan Norse") return("Ox Caravan");
	if(thing=="Caravan Egyptian") return("Camel Caravan");
	if(thing=="Female") return("Greta Forkbeard");
	if(thing=="Mercenary Cavalry") return("Merc. Cav");
	if(thing=="Dwarf") return("Dwarf");
      return(thing);
}

void addLoopingInstructions(int startTime=0, int repeatTime=80,
	string s1="", string s2="", string s3="", string s4="", string s5="") {

	int id = rmCreateTrigger("instructions_loop_"+startTime);
	rmSwitchToTrigger(id);
	rmSetTriggerLoop(true);
	rmSetTriggerPriority(3);
	rmSetTriggerActive(false);
	newCondition("Timer");
	 condParam("Param1", ""+repeatTime);
	newCondition("Player Unit Count");
	 condParam("PlayerID", "1");
	 condParam("ProtoUnit", "Wall Connector");
	 condParam("Op", ">=");
	 condParam("Count", "1");
	if(s1!="") sendChat(s1);
	if(s2!="") sendChat(s2);
	if(s3!="") sendChat(s3);
	if(s4!="") sendChat(s4);
	if(s5!="") sendChat(s5);
	int k = id;

	id = rmCreateTrigger("instructions_loop_"+startTime+"_start");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	newCondition("Timer");
	 condParam("Param1", ""+startTime);
	if(s1!="") sendChat(s1);
	if(s2!="") sendChat(s2);
	if(s3!="") sendChat(s3);
	if(s4!="") sendChat(s4);
	if(s5!="") sendChat(s5);
	newEffect("Fire Event");
	 effectParam("EventID", ""+k);
}

void addRavens(int time=0) {
	for(i=1; <cNumberPlayers) {
		int count = 0;
		if(rmGetPlayerCiv(i) == cCivOdin) {
			count = 2;
		}

		for(j=0; <count) {
			// create army
			int army = rmCreateArmy(i, "raven"+j+"_p"+i);

			// create trigger
			int id = rmCreateTrigger("raven"+j+"_p"+i);
			rmSwitchToTrigger(id);
			rmSetTriggerLoop(true);
			rmSetTriggerPriority(3);
			newCondition("Army Is Dead");
			 condParamArmy("SrcArmy", i, army);
			newCondition("Timer");
			 condParam("Param1", ""+time);
			newCondition("Units In Area");
			 condParam("Player", ""+i);
			 condParam("DstObject", getStart(i));
			 condParam("UnitType", "Hill Fort");
			 condParam("Op", ">=");
			 condParam("Dist", "10.0");
			 condParam("Count", "1");
			newEffect("Army Deploy");
			 effectParamArmy("SrcArmy", i, army);
			 effectParam("ProtoName", "Raven");
			 effectParam("Count", "1");
			 effectParam("Heading", "0");
			 effectParam("Clear", "true");
			 effectParam("Location", playerSpawnLoc(i));
			newEffect("Army Move");
			 effectParamArmy("SrcArmy", i, army);
			 effectParam("DstPoint", playerGatherLoc(i));
			 effectParam("AttackMove", "false");
		 }
	}
}

void addSpawningUnit(string name="", int count=0, int time=0, int minFav=0, int maxFav=0, string chooserUnit="") {
	for(i=1; <cNumberPlayers) {
		int id = rmCreateTrigger("fav"+minFav+"_"+maxFav+"_"+name+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(4);
		newCondition("Timer");
		 condParam("Param1", ""+time);
		newCondition("Player Resource Count");
		 condParam("PlayerID", ""+i);
		 condParam("Resource", "favor");
		 condParam("Op", ">=");
		 condParam("Count", ""+minFav);
		newCondition("Player Resource Count");
		 condParam("PlayerID", ""+i);
		 condParam("Resource", "favor");
		 condParam("Op", "<=");
		 condParam("Count", ""+maxFav);
		newCondition("Player Population");
		 condParam("PlayerID", ""+i);
		 condParam("Op", "<");
		 condParam("Count", ""+POP_LIMIT);
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getStart(i));
		 condParam("UnitType", "Hill Fort");
		 condParam("Op", ">=");
		 condParam("Dist", "10.0");
		 condParam("Count", "1");
		if(chooserUnit=="inf") {
			newCondition("Distance to Unit");
			 condParam("SrcObject", getChooser(i));
			 condParam("DstObject", getInfUnit(i));
			 condParam("Op", "<=");
			 condParam("Dist", "0.5");
		}
		else if(chooserUnit=="arc") {
			newCondition("Distance to Unit");
			 condParam("SrcObject", getChooser(i));
			 condParam("DstObject", getArcUnit(i));
			 condParam("Op", "<=");
			 condParam("Dist", "0.5");
		}
		else if(chooserUnit=="cav") {
			newCondition("Distance to Unit");
			 condParam("SrcObject", getChooser(i));
			 condParam("DstObject", getCavUnit(i));
			 condParam("Op", "<=");
			 condParam("Dist", "0.5");
		}
		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", name);
		 effectParam("Count", ""+count);
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", playerSpawnLoc(i));
		newEffect("Army Move");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("DstPoint", playerGatherLoc(i));
		 effectParam("AttackMove", "true");

		if(chooserUnit=="inf" || chooserUnit=="cav" || chooserUnit=="arc") {
			id = rmCreateTrigger("fav"+minFav+"_"+maxFav+"_"+name+"_change_p"+i);
			rmSwitchToTrigger(id);
			rmSetTriggerLoop(true);
			rmSetTriggerPriority(3);
			newCondition("Timer");
			 condParam("Param1", ""+time);
			newCondition("Player Resource Count");
			 condParam("PlayerID", ""+i);
			 condParam("Resource", "favor");
			 condParam("Op", ">=");
			 condParam("Count", ""+minFav);
			newCondition("Player Resource Count");
			 condParam("PlayerID", ""+i);
			 condParam("Resource", "favor");
			 condParam("Op", "<=");
			 condParam("Count", ""+maxFav);
			newCondition("Units In Area");
			 condParam("Player", ""+i);
			 condParam("DstObject", getStart(i));
			 condParam("UnitType", "Hill Fort");
			 condParam("Op", ">=");
			 condParam("Dist", "10.0");
			 condParam("Count", "1");
			if(chooserUnit=="inf") {
				newEffect("Change Unit Type");
				 effectParam("SrcObject", getInfUnit(i));
				 effectParam("ProtoUnit", name);
			}
			else if(chooserUnit=="arc") {
				newEffect("Change Unit Type");
				 effectParam("SrcObject", getArcUnit(i));
				 effectParam("ProtoUnit", name);
			}
			else if(chooserUnit=="cav") {
				newEffect("Change Unit Type");
				 effectParam("SrcObject", getCavUnit(i));
				 effectParam("ProtoUnit", name);
			}
		}
	}
}

void addReinforcements(int time=0) {
	for(i=1; <cNumberPlayers) {
		int id = rmCreateTrigger("reinforcements_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(4);
		newCondition("Timer");
		 condParam("Param1", ""+time);
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getStart(i));
		 condParam("UnitType", "Hill Fort");
		 condParam("Op", ">=");
		 condParam("Dist", "10.0");
		 condParam("Count", "1");
		string unit = ""; int unitNum = 0;
		string unit2 = ""; int unitNum2 = 0;
		if(rmGetPlayerCiv(i)==cCivLoki) {
			unit = "Archer Atlantean Hero"; unitNum = 5;
			unit2 = "Battle Boar"; unitNum2 = 2;
		}
		else if(rmGetPlayerCiv(i)==cCivThor) {
			unit = "Hero Ragnorok"; unitNum = 5;
			unit2 = "Nemean Lion"; unitNum2 = 2;
		}
		else if(rmGetPlayerCiv(i)==cCivOdin) {
			unit = "Lancer Hero"; unitNum = 5;
			unit2 = "Valkyrie"; unitNum2 = 2;
		}
		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", unit);
		 effectParam("Count", ""+unitNum);
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", playerSpawnLoc(i));

		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", unit2);
		 effectParam("Count", ""+unitNum2);
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", playerSpawnLoc(i));


		newEffect("Army Move");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("DstPoint", playerGatherLoc(i));
		 effectParam("AttackMove", "true");
		if(rmGetPlayerCiv(i)==cCivLoki) {
			grantTech(i, cTechRelicTriosBow);
			modifyProtoUnitFor(i, "Throwing Axeman", 11, 2);
			modifyProtoUnitFor(i, "Throwing Axeman", 2, 2);
		}
		else if(rmGetPlayerCiv(i)==cCivThor) {
			modifyProtoUnitFor(i, "Ulfsark", 27, 0.5); // Ulfsark Attack
			newEffect("Grant Resources");
			 effectParam("PlayerID", ""+i);
			 effectParam("ResName", "favor");
			 effectParam("Amount", "12");
		}
		else if(rmGetPlayerCiv(i)==cCivOdin) {
			grantTech(i, cTechRelicTuskoftheIronBoar);
			modifyProtoUnit("Hetairoi", 0, 7);  // Hetairoi HP
			modifyProtoUnit("Lancer Hero", 0, 5);  // Contarius HP
			modifyProtoUnit("Lancer", 0, 3);
			modifyProtoUnit("Raiding Cavalry", 0, 2);
			modifyProtoUnit("Prodromos", 0, 2);
			modifyProtoUnit("Camelry", 0, 2);
			modifyProtoUnit("Hippikon", 0, 3);
		}
	}

	int id2 = rmCreateTrigger("reinforcementsLoop");
	rmSwitchToTrigger(id2);
	rmSetTriggerLoop(false);
	rmSetTriggerActive(false);
	rmSetTriggerPriority(4);
	sendChat("<color=0.2,0.8,0.2>REINFORCEMENTS HAVE ARRIVED!</color>");
	sendChat(iconThor+"<color=0.2,0.8,0.2>Thor</color>:"+" 5 Ragnarok Heroes, 2 Nemean Lions, 12 favor, Ulf +0.5 Attack");
	sendChat(iconOdin+"<color=0.2,0.8,0.2>Odin</color>:"+" 5 Contarius Heroes, 2 Valkyries, Cavalry +10%% HP");
	sendChat(iconLoki+"<color=0.2,0.8,0.2>Loki</color>:"+" 5 Arcus Heroes, 2 Battle Boars, Archers +2 Range");
	newEffect("Sound Filename");
	 effectParam("Sound", "\dialog\genr062.mp3");
	newEffect("Counter Stop");
	 effectParam("Name", "reinforcements");
	newEffect("Counter:Add Timer");
	 effectParam("Name", "reinforcements");
	 effectParam("Msg", "Next Reinforcements");
	 effectParam("Start", ""+time);
	 effectParam("Stop", "0");
	 effectParam("Event", ""+id2);

	int id3 = rmCreateTrigger("reinforecementsBegin");
	rmSwitchToTrigger(id3);
	rmSetTriggerLoop(false);
	rmSetTriggerPriority(4);
	newEffect("Counter:Add Timer");
	 effectParam("Name", "reinforcements");
	 effectParam("Msg", "Next Reinforcements");
	 effectParam("Start", ""+time);
	 effectParam("Stop", "0");
	 effectParam("Event", ""+id2);
}

void addGaiaPower(string name="", int time=0) {

	int id1 = rmCreateTrigger("gaiaInvoke_"+name+"_"+time);
	rmSwitchToTrigger(id1);
	rmSetTriggerLoop(false);
	rmSetTriggerPriority(4);
	rmSetTriggerActive(false);
	newCondition("Timer");
	 condParam("Param1", ""+1);
	newEffect("Grant God Power");
	 effectParam("PlayerID", ""+0);
	 effectParam("Count", "1");
	 effectParam("PowerName", name);
	newEffect("Invoke God Power");
	 effectParam("PlayerID", "0");
	 effectParam("DstPoint1", pointLoc(0.5,0.5));
	 effectParam("PowerName", name);

	int id2 = rmCreateTrigger("gaiaLoop_"+name+"_"+time);
	rmSwitchToTrigger(id2);
	rmSetTriggerLoop(false);
	rmSetTriggerActive(false);
	rmSetTriggerPriority(4);
	sendChat("<color=1.0,0.2,0.0>FEEL THE POWER OF THE GODS!!</color>");
	newEffect("Grant God Power");
	 effectParam("PlayerID", "0");
	 effectParam("Count", "1");
	 effectParam("PowerName", "Vision");
	newEffect("Invoke God Power");
	 effectParam("PlayerID", "0");
	 effectParam("DstPoint1", pointLoc(0.5,0.5));
	 effectParam("PowerName", "Vision");
	newEffect("Fire Event");
	 effectParam("EventID", ""+id1);
	newEffect("Sound Filename");
	 effectParam("Sound", "\dialog\garg119.mp3");
	newEffect("Counter Stop");
	 effectParam("Name", "gaiaPower_"+name+"_"+time);
	newEffect("Counter:Add Timer");
	 effectParam("Name", "gaiaPower_"+name+"_"+time);
	 effectParam("Msg", "Next "+name);
	 effectParam("Start", ""+time);
	 effectParam("Stop", "0");
	 effectParam("Event", ""+id2);

	int id3 = rmCreateTrigger("gaiaBegin_"+name+"_"+time);
	rmSwitchToTrigger(id3);
	rmSetTriggerLoop(false);
	rmSetTriggerPriority(4);
	newEffect("Counter:Add Timer");
	 effectParam("Name", "gaiaPower_"+name+"_"+time);
	 effectParam("Msg", "Next "+name);
	 effectParam("Start", ""+time);
	 effectParam("Stop", "0");
	 effectParam("Event", ""+id2);
}

void addBuyableUnit(int mx=0, int mz=0, string name="", int favor=0, int isMyth=0) {
	for(i=1; <cNumberPlayers) {
		// figure out the true cost for this player (for Loki -10% bonus)
		int cost = favor;
		if(isMyth==1 && rmGetPlayerCiv(i)==cCivLoki) {
			cost = cost * 90 / 100;
		}

		// create the summoner object
		int id=rmCreateObjectDef("buy"+favor+"_"+name+"_"+i);
		rmAddObjectDefItem(id, name, 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, offX(getSpecialX(i),mx), offZ(getSpecialZ(i),mz));

		// create the buy trigger
		id = rmCreateTrigger("buy"+favor+"_"+name+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		newCondition("Timer");
		 condParam("Param1", "2");
		newCondition("Player Resource Count");
		 condParam("PlayerID", ""+i);
		 condParam("Resource", "favor");
		 condParam("Op", ">=");
		 condParam("Count", ""+cost);
		newCondition("Player Population");
		 condParam("PlayerID", ""+i);
		 condParam("Op", "<");
		 condParam("Count", ""+POP_LIMIT);
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getStart(i));
		 condParam("UnitType", "Hill Fort");
		 condParam("Op", ">=");
		 condParam("Dist", "10.0");
		 condParam("Count", "1");
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getMonument(i));
		 condParam("UnitType", name);
		 condParam("Op", ">=");
		 condParam("Dist", "3.7");
		 condParam("Count", "1");
		newEffect("Grant Resources");
		 effectParam("PlayerID", ""+i);
		 effectParam("ResName", "favor");
		 effectParam("Amount", ""+(""+(0-cost)));
		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", name);
		 effectParam("Count", "1");
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", playerSpawnLoc(i));
		newEffect("Army Move");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("DstPoint", playerGatherLoc(i));
		 effectParam("AttackMove", "true");
		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", "Hero Death");
		 effectParam("Count", "1");
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", pointLoc(getSpecialX(i), getSpecialZ(i)));
	}
}



void addUniqueUnit(int mx=0, int mz=0, int i=0, string name="", int favor=0) {	// i is the player number
	// create the summoner object
	int id=rmCreateObjectDef("buy"+favor+"_"+name+"_"+i);
	rmAddObjectDefItem(id, name, 1, 0.0);
	rmSetObjectDefMinDistance(id, 0.0);
	rmSetObjectDefMaxDistance(id, 0.0);
	rmPlaceObjectDefAtLoc(id, i, offX(getSpecialX(i),mx), offZ(getSpecialZ(i),mz));


	id = rmCreateTrigger("buy"+favor+"_"+name+"_init"+i);
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	modifyProtoUnitFor(i, name, 19, favor);   // favor cost

	// create the buy trigger
	id = rmCreateTrigger("buy"+favor+"_"+name+"_p"+i);
	rmSwitchToTrigger(id);
	rmSetTriggerLoop(true);
	rmSetTriggerPriority(3);
	newCondition("Timer");
	 condParam("Param1", "2");
	newCondition("Player Resource Count");
	 condParam("PlayerID", ""+i);
	 condParam("Resource", "favor");
	 condParam("Op", ">=");
	 condParam("Count", ""+favor);
	newCondition("Player Population");
	 condParam("PlayerID", ""+i);
	 condParam("Op", "<");
	 condParam("Count", ""+POP_LIMIT);
	newCondition("Units In Area");
	 condParam("Player", ""+i);
	 condParam("DstObject", getStart(i));
	 condParam("UnitType", "Hill Fort");
	 condParam("Op", ">=");
	 condParam("Dist", "10.0");
	 condParam("Count", "1");
	newCondition("Units In Area");
	 condParam("Player", ""+i);
	 condParam("DstObject", getMonument(i));
	 condParam("UnitType", name);
	 condParam("Op", ">=");
	 condParam("Dist", "3.7");
	 condParam("Count", "1");
	newEffect("Grant Resources");
	 effectParam("PlayerID", ""+i);
	 effectParam("ResName", "favor");
	 effectParam("Amount", ""+(""+(0-favor)));
	newEffect("Army Deploy");
	 effectParamArmy("SrcArmy", i, getArmy(i));
	 effectParam("ProtoName", name);
	 effectParam("Count", "1");
	 effectParam("Heading", "0");
	 effectParam("Clear", "true");
	 effectParam("Location", playerSpawnLoc(i));
	newEffect("Army Move");
	 effectParamArmy("SrcArmy", i, getArmy(i));
	 effectParam("DstPoint", playerGatherLoc(i));
	 effectParam("AttackMove", "true");
	newEffect("Army Deploy");
	 effectParamArmy("SrcArmy", i, getArmy(i));
	 effectParam("ProtoName", "Hero Death");
	 effectParam("Count", "1");
	 effectParam("Heading", "0");
	 effectParam("Clear", "true");
	 effectParam("Location", pointLoc(getSpecialX(i), getSpecialZ(i)));
}

int addedGodPowerActivation = 0;
int curPowerNumber=1;
void addGodPowerUnit(int mx=0, int mz=0, string unit="", string power="", int favor=0) {
	string displayName = realName(power);

	for(i=1; <cNumberPlayers) {
		// figure out the true cost for this player (for Odin -12% bonus)
		int cost = favor;
		if(rmGetPlayerCiv(i)==cCivOdin) {
			cost = cost * 88 / 100;
		}

		cost = cost * SB_GP_MULT;

		// create the summoner object
		int id=rmCreateObjectDef("gp"+favor+"_"+power+"_"+i);
		rmAddObjectDefItem(id, unit, 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, offX(getSpecialX(i),mx), offZ(getSpecialZ(i),mz));

		// create the activate trigger
		if(addedGodPowerActivation==0) {
			id = rmCreateTrigger("activate_gp_buying_p"+i);
			rmSwitchToTrigger(id);
			rmSetTriggerPriority(4);
			newCondition("Timer");
			 condParam("Param1", ""+(LURE_END_TIME+5));
			grantTech(i, cTechHusbandry);
		}

		// create the init trigger
		id = rmCreateTrigger("init_"+curPowerNumber+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerRunImmediately(true);
		newEffect("Quest Var Set");
		 effectParam("QVName", "can_buy_"+curPowerNumber+"_p"+i);
		 effectParam("Value", "1");
		newEffect("Quest Var Set");
		 effectParam("QVName", "bought_"+curPowerNumber+"_p"+i);
		 effectParam("Value", "0");
		newEffect("Quest Var Set");
		 effectParam("QVName", "killed_"+curPowerNumber+"_p"+i);
		 effectParam("Value", "0");

		modifyProtoUnitFor(i, unit, 19, cost);   // favor cost display


		int idActive = rmCreateTrigger("active_"+curPowerNumber+"_p"+i);
		int idReenable = rmCreateTrigger("reenable_"+curPowerNumber+"_p"+i);

		// create the active check
		rmSwitchToTrigger(idActive);
		rmSetTriggerPriority(5);
		newCondition("Quest Var Check");
		 condParam("QuestVar", "bought_"+curPowerNumber+"_p"+i);
		 condParam("Op", "==");
		 condParam("Value", "1");
		newCondition("God Power Active");
		 condParam("PowerName", power);
		 condParam("Player", ""+i);
		newEffect("Fire Event");
		 effectParam("EventID", ""+idReenable);
		newEffect("Quest Var Set");
		 effectParam("QVName", "bought_"+curPowerNumber+"_p"+i);
		 effectParam("Value", "0");
		 	newEffect("Player Kill All God Powers");
			 effectParam("Player", ""+i);
	 	for(j=1; <=4) {
			newEffect("Quest Var Set");
			 effectParam("QVName", "killed_"+j+"_p"+i);
			 effectParam("Value", "1");
		}
		//sendChat("Active "+curPowerNumber);

		// create the reenable
		rmSwitchToTrigger(idReenable);
		rmSetTriggerActive(false);
		rmSetTriggerPriority(5);
		newCustomCondition("trCheckGPActive(\""+power+"\", "+i+")==false");
		newEffect("Quest Var Set");
		 effectParam("QVName", "can_buy_"+curPowerNumber+"_p"+i);
		 effectParam("Value", "1");
		newEffect("Fire Event");
		 effectParam("EventID", ""+idActive);
		sendChatTo(i, "<color=0.2,0.8,0.2>You can buy "+displayName+" again now.</color>");

		// create the buy trigger
		id = rmCreateTrigger("buy"+favor+"_"+power+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		newCondition("Timer");
		 condParam("Param1", "4");
		newCondition("Tech Available");
		 condParam("PlayerID", ""+i);
		 condParam("TechID", ""+cTechHusbandry);
		newCondition("Player Resource Count");
		 condParam("PlayerID", ""+i);
		 condParam("Resource", "favor");
		 condParam("Op", ">=");
		 condParam("Count", ""+cost);
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getStart(i));
		 condParam("UnitType", "Hill Fort");
		 condParam("Op", ">=");
		 condParam("Dist", "10.0");
		 condParam("Count", "1");
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getMonument(i));
		 condParam("UnitType", unit);
		 condParam("Op", ">=");
		 condParam("Dist", "3.7");
		 condParam("Count", "1");
		newEffect("Grant Resources");
		 effectParam("PlayerID", ""+i);
		 effectParam("ResName", "favor");
		 effectParam("Amount", ""+(0-cost));
		newEffect("Grant God Power");
		 effectParam("PlayerID", ""+i);
		 effectParam("Count", "1");
		 effectParam("PowerName", power);
		newEffect("Quest Var Set");
		 effectParam("QVName", "killed_"+curPowerNumber+"_p"+i);
		 effectParam("Value", "0");
		newEffect("Quest Var Set");
		 effectParam("QVName", "bought_"+curPowerNumber+"_p"+i);
		 effectParam("Value", "1");
		sendChat(coloredPlayerName(i)+"<color=0.7,0.7,0.7> has purchased a "+displayName+"!</color>", 0);
		newEffect("Sound Filename");
		 effectParam("Sound", "lightningstrike3.wav");
		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", "Hero Birth");
		 effectParam("Count", "1");
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", pointLoc(getSpecialX(i), getSpecialZ(i)));

		newCondition("Quest Var Check");
		 condParam("QuestVar", "can_buy_"+curPowerNumber+"_p"+i);
		 condParam("Op", "==");
		 condParam("Value", "1");

		newEffect("Quest Var Set");
		 effectParam("QVName", "can_buy_"+curPowerNumber+"_p"+i);
		 effectParam("Value", "0");
		sendChatTo(i, "<color=1.0,0.2,0.0>You can't buy another "+
			displayName+" until you use/lose this one.</color>");

		// create the regrant

		id = rmCreateTrigger("regrant_"+curPowerNumber+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(5);
		newCondition("Timer");
		 condParam("Param1", "1");
		newCondition("Quest Var Check");
		 condParam("QuestVar", "bought_"+curPowerNumber+"_p"+i);
		 condParam("Op", "==");
		 condParam("Value", "1");
		newCondition("Quest Var Check");
		 condParam("QuestVar", "killed_"+curPowerNumber+"_p"+i);
		 condParam("Op", "==");
		 condParam("Value", "1");
		newEffect("Quest Var Set");
		 effectParam("QVName", "killed_"+curPowerNumber+"_p"+i);
		 effectParam("Value", "0");
		newEffect("Grant God Power");
		 effectParam("PlayerID", ""+i);
		 effectParam("Count", "1");
		 effectParam("PowerName", power);

		//sendChat("Regranted "+curPowerNumber);

		id = rmCreateTrigger("dont_regrant_"+curPowerNumber+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(5);
		newCondition("Timer");
		 condParam("Param1", "1");
		newCondition("Quest Var Check");
		 condParam("QuestVar", "bought_"+curPowerNumber+"_p"+i);
		 condParam("Op", "==");
		 condParam("Value", "0");
		newCondition("Quest Var Check");
		 condParam("QuestVar", "killed_"+curPowerNumber+"_p"+i);
		 condParam("Op", "==");
		 condParam("Value", "1");
		newEffect("Quest Var Set");
		 effectParam("QVName", "killed_"+curPowerNumber+"_p"+i);
		 effectParam("Value", "0");
		//sendChat("Didnt regrant "+curPowerNumber);
	}

	addedGodPowerActivation=1;
	curPowerNumber = curPowerNumber+1;
}

void addTechUnit(int mx=0, int mz=0, string unit="", string name="", int tech=0, int favor=0, int maxCount=7, int rampAmount=1, string desc="") {
	int id=0;
	int k2=0;

	rampAmount = SB_Rampup * rampAmount;
	if (SB_maxup == 1)
		maxCount = 200;

	for(i=1; <cNumberPlayers) {
		// figure out the true cost for this player (for Thor -7% bonus)
		int cost = favor;
		if(rmGetPlayerCiv(i)==cCivThor) {
			cost = cost*93/100;
		}

		// variable names
		string costVar = "p"+i+"_tech"+tech+"_cost";
		string countVar = "p"+i+"_tech_count";

		// create the init trigger
		id = rmCreateTrigger("tech_"+tech+"_p"+i+"_init");
		rmSwitchToTrigger(id);
		rmSetTriggerPriority(4);
		newEffect("Quest Var Set");
		 effectParam("QVName", costVar);
		 effectParam("Value", ""+cost);
		newEffect("Quest Var Set");
		 effectParam("QVName", countVar);
		 effectParam("Value", "0");
		// init favor cost
		//modifyProtoUnitForStr(i, unit, 19, "0-35");   // favor cost
		if (unit=="Oracle Hero")
		{
			modifyProtoUnitFor(i, unit, 16, -65);   // gold cost
			modifyProtoUnitFor(i, unit, 18, -40);   // food cost
			modifyProtoUnitFor(i, unit, 19, -2);   // favor cost
		}
		modifyProtoUnitFor(i, unit, 19, cost);   // favor cost

		// create the summoner object
		id = rmCreateObjectDef("tech_"+tech+"_"+i);
		rmAddObjectDefItem(id, unit, 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, offX(getSpecialX(i),mx), offZ(getSpecialZ(i),mz));

		// change summoner name
		k=""+rmGetUnitPlaced(id,0);
		k2 = rmGetUnitPlaced(id,0);
		/*

		Doesn't work mother fuckin biaaatch!!!

		id = rmCreateTrigger("changeName_"+k);
		rmSwitchToTrigger(id);
		rmSetTriggerPriority(3);
		rmSetTriggerRunImmediately(true);

		//newCustomEffect("trUnitSelectClear(); trUnitSelectByID("+k2+"); trUnitChangeName(\""+desc+"\");");


		newEffect("Change Name");
		 effectParam("SrcObject", k);
		 effectParam("NewName", desc);
		*/

		// create the buy trigger
		id = rmCreateTrigger("tech_"+tech+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		newCondition("Timer");
		 condParam("Param1", "3");
		newCondition("Quest Var Check");
		 condParam("QuestVar", countVar);
		 condParam("Op", "<");
		 condParam("Value", ""+maxCount);
		newCondition("Player Resource Count");
		 condParam("PlayerID", ""+i);
		 condParam("Resource", "favor");
		 condParam("Op", ">=");
		 condParam("Count", "trQuestVarGet(\""+costVar+"\")");
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getStart(i));
		 condParam("UnitType", "Hill Fort");
		 condParam("Op", ">=");
		 condParam("Dist", "10.0");
		 condParam("Count", "1");
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getMonument(i));
		 condParam("UnitType", unit);
		 condParam("Op", ">=");
		 condParam("Dist", "3.7");
		 condParam("Count", "1");
		newEffect("Grant Resources");
		 effectParam("PlayerID", ""+i);
		 effectParam("ResName", "favor");
		 effectParam("Amount", "0-trQuestVarGet(\""+costVar+"\")");
		newEffect("Set Tech Status");
		 effectParam("PlayerID", ""+i);
		 effectParam("TechID", ""+tech);
		 effectParam("Status", ""+cTechStatusActive);
		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", "Regeneration SFX");
		 effectParam("Count", "1");
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", pointLoc(getSpecialX(i), getSpecialZ(i)));
		newEffect("Quest Var Modify");
		 effectParam("QVName", countVar);
		 effectParam("Oper", "+");
		 effectParam("Value", "1");

		// Add +1 to all costs
		if (tech == cTechIronWeapons || tech == cTechIronMail || tech == cTechIronShields)
		{
			newEffect("Quest Var Modify");
			 effectParam("QVName", "p"+i+"_tech"+cTechIronWeapons+"_cost");
			 effectParam("Oper", "+");
			 effectParam("Value", ""+rampAmount);
			newEffect("Quest Var Modify");
			 effectParam("QVName", "p"+i+"_tech"+cTechIronMail+"_cost");
			 effectParam("Oper", "+");
			 effectParam("Value", ""+rampAmount);
			newEffect("Quest Var Modify");
			 effectParam("QVName", "p"+i+"_tech"+cTechIronShields+"_cost");
			 effectParam("Oper", "+");
			 effectParam("Value", ""+rampAmount);
			modifyProtoUnitFor(i, "Brokk", 19, rampAmount);   // favor cost
			modifyProtoUnitFor(i, "Eitri", 19, rampAmount);   // favor cost
			modifyProtoUnitFor(i, "Skult", 19, rampAmount);   // favor cost
	    }
	    else
	    {
			newEffect("Quest Var Modify");
			 effectParam("QVName", "p"+i+"_tech"+tech+"_cost");
			 effectParam("Oper", "+");
			 effectParam("Value", ""+rampAmount);
			 modifyProtoUnitFor(i, unit, 19, rampAmount);   // favor cost
	    }

		newCustomEffect("int newCost = trQuestVarGet(\""+costVar+"\");");
		sendChatTo(i, iconFavor+"Your "+name+" upgrade now costs <color=1.0,0.2,0.0>\"+newCost+\"</color> favor.");



		// increase weapons more than others
		if (tech == cTechIronWeapons)
		{
			id = rmCreateTrigger("weapons_"+i+"_additional_at_5");
			rmSwitchToTrigger(id);
			rmSetTriggerPriority(3);
			newCondition("Quest Var Check");
			 condParam("QuestVar", countVar);
			 condParam("Op", ">=");
			 condParam("Value", "5");
			newEffect("Quest Var Modify");
			 effectParam("QVName", "p"+i+"_tech"+cTechIronWeapons+"_cost");
			 effectParam("Oper", "+");
			 effectParam("Value", ""+rampAmount);
			modifyProtoUnitFor(i, unit, 19, rampAmount);   // favor cost

			id = rmCreateTrigger("weapons_"+i+"_additional_at_15");
			rmSwitchToTrigger(id);
			rmSetTriggerPriority(3);
			newCondition("Quest Var Check");
			 condParam("QuestVar", countVar);
			 condParam("Op", ">=");
			 condParam("Value", "15");
			newEffect("Quest Var Modify");
			 effectParam("QVName", "p"+i+"_tech"+cTechIronWeapons+"_cost");
			 effectParam("Oper", "+");
			 effectParam("Value", ""+rampAmount);
			modifyProtoUnitFor(i, unit, 19, rampAmount);   // favor cost

			id = rmCreateTrigger("weapons_"+i+"_additional_at_25");
			rmSwitchToTrigger(id);
			rmSetTriggerPriority(3);
			newCondition("Quest Var Check");
			 condParam("QuestVar", countVar);
			 condParam("Op", ">=");
			 condParam("Value", "25");
			newEffect("Quest Var Modify");
			 effectParam("QVName", "p"+i+"_tech"+cTechIronWeapons+"_cost");
			 effectParam("Oper", "+");
			 effectParam("Value", ""+rampAmount);
			modifyProtoUnitFor(i, unit, 19, rampAmount);   // favor cost
		 }


		// create the cap reached trigger
		id = rmCreateTrigger("tech_p"+i+"_"+tech+"_cap");
		rmSwitchToTrigger(id);
		rmSetTriggerPriority(3);
		newCondition("Quest Var Check");
		 condParam("QuestVar", countVar);
		 condParam("Op", ">=");
		 condParam("Value", ""+maxCount);
		sendChatTo(i, iconFavorFull+"<color=1.0,0.2,0.0>Your have reached your "+maxCount+" upgrades cap.</color>");
	}
}

void addHelpUnit(int mx=0, int mz=0, string unit="") {

	for(i=1; <cNumberPlayers) {

		// create the summoner object
		int id=rmCreateObjectDef("help_"+i);
		rmAddObjectDefItem(id, unit, 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, offX(getSpecialX(i),mx), offZ(getSpecialZ(i),mz));

		// create the buy trigger
		id = rmCreateTrigger("help_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		newCondition("Timer");
		 condParam("Param1", "6");
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getStart(i));
		 condParam("UnitType", "Hill Fort");
		 condParam("Op", ">=");
		 condParam("Dist", "10.0");
		 condParam("Count", "1");
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getMonument(i));
		 condParam("UnitType", unit);
		 condParam("Op", ">=");
		 condParam("Dist", "3.7");
		 condParam("Count", "1");
		string uniqueUnitInfo = "";
		if(rmGetPlayerCiv(i)==cCivThor) uniqueUnitInfo="Dwarf Decoy(4)";
		if(rmGetPlayerCiv(i)==cCivOdin) uniqueUnitInfo="Cataphract(3)";
		if(rmGetPlayerCiv(i)==cCivLoki) uniqueUnitInfo="Katapeltes(2)";
		int gpMult=100; if(rmGetPlayerCiv(i)==cCivOdin) gpMult=88;
		int muMult=100; if(rmGetPlayerCiv(i)==cCivLoki) muMult=90;
		newCustomEffect("int at = trQuestVarGet(\"p"+i+"_tech"+cTechIronWeapons+"_cost\");");
		newCustomEffect("int ma = trQuestVarGet(\"p"+i+"_tech"+cTechIronMail+"_cost\");");
		newCustomEffect("int sh = trQuestVarGet(\"p"+i+"_tech"+cTechIronShields+"_cost\");");
		newCustomEffect("int mu = trQuestVarGet(\"p"+i+"_tech"+cTechMonstrousRage+"_cost\");");

		newCustomEffect("int ph = trQuestVarGet(\"p"+i+"_Pharaoh_cost\");");
		newCustomEffect("int her = trQuestVarGet(\"p"+i+"_Hero Norse_cost\");");
		newCustomEffect("int soo = trQuestVarGet(\"p"+i+"_Pharaoh of Osiris_cost\");");
		newCustomEffect("int cir = trQuestVarGet(\"p"+i+"_Circe_cost\");");
	        newCustomEffect("int bel = trQuestVarGet(\"p"+i+"_Hero Greek Bellerophon_cost\");");

        //SUPER ARCHER

        if (sArc3 == "Archer Atlantean") {
	        newCustomEffect("int SA = trQuestVarGet(\"p"+i+"_Toxotes_cost\");");
	}
	else {
	        newCustomEffect("int SA = trQuestVarGet(\"p"+i+"_Archer Atlantean_cost\");");
	}

		newCustomEffect("int or = trQuestVarGet(\"p"+i+"_tech"+cTechOracle+"_cost\");");
		newCustomEffect("int ga = trQuestVarGet(\"p"+i+"_garrison_cost\");");
		newCustomEffect("int kills = trGetStatValue("+i+", 2);");


		sendChatsTo(i,
			 "<color=0.9,0.5,0.0>Costs for store island:</color>"+" (move a unit to monument to buy)",
			 "<color=0.9,0.5,0.4>Units</color>: "+nMU1+"("+(iMU1Cost*muMult/100)+"), "
				+nMU2+"("+(iMU2Cost*muMult/100)+"), "
				+nHero+"("+iHeroCost+"), "+uniqueUnitInfo,
			 "<color=0.9,0.5,0.3>Techs</color>: <color=0.9,0.5,0.8>Skult=Atk(\"+at+\"), "+
				"Brokk=Mail(\"+ma+\"), Eitri=Shld(\"+sh+\") ," +
				"Kems=MU(\"+mu+\"),</color>",
			 "        <color=0.9,0.5,0.8>Oracle=LOS(\"+or+\")" +
				", Greta Forkbeard=HF capacity(\"+ga+\")</color>",
			 "<color=0.9,0.5,0.0>Powers</color>: Arkantos=Lightning Storm("+(30*gpMult/100)+"),"
				+" Amanra=Shift.Sands("+(30*gpMult/100)+")",
				"        "+nPower1Caster+"="+nPower1+"("+(iPower1Cost*gpMult/100)+"), "
				+nPower2Caster+"="+nPower2+"("+(iPower2Cost*gpMult/100)+")",
			 "<color=2.9,0.9,0.1>Super Units:<color=7.9,0.2,0.2> Pharaoh(\"+ph+\"), Hersir(\"+her+\"), </color>",
                         "<color=7.9,0.2,0.2>                                 Bellerophon(\"+bel+\"), Circe(\"+cir+\"), "+"Super Archer(\"+SA+\")</color>"
			);
		sendChatTo(i, "<color=0.9,0.5,0.3>You Currently Have \"+kills+\" kills.</color>");


	}

}

string bonusType1 = "unit";	// could be "unit" or "tech"
string bonusName1 = "";
int bonusAmount1 = 0;
string bonusDesc1 = "";

string bonusType2 = "unit";
string bonusName2 = "";
int bonusAmount2 = 0;
string bonusDesc2 = "";

string bonusType3 = "unit";
string bonusName3 = "";
int bonusAmount3 = 0;
string bonusDesc3 = "";

void addBonusChoice(int i=0, int kills=0, string chooser="", string bonusChoice="", string bonusType="",
	string bonusName="", int bonusAmount=0, string bonusDesc="") {

	int num = guid();
	int j=0;

	int id = rmCreateTrigger("bonus"+kills+"_p"+i+"_choice"+num);
	rmSwitchToTrigger(id);
	newCondition("Units In Area");
	 condParam("Player", ""+i);
	 condParam("DstObject", bonusChoice);
	 condParam("Dist", "3.7");
	 condParam("UnitType", chooser);
	 condParam("Op", ">=");
	 condParam("Count", "1");
	newCondition("Quest Var Check");
	 condParam("QuestVar", "can_choose_bonus_"+kills+"_p"+i);
	 condParam("Op", "==");
	 condParam("Value", "1");
	newEffect("Quest Var Set");
	 effectParam("QVName", "can_choose_bonus_"+kills+"_p"+i);
	 effectParam("Value", "0");
	newEffect("Change Units In Area");
	 effectParam("SrcObject", bonusMonument);
	 effectParam("Dist", "20");
	 effectParam("FromPlayerID", ""+i);
	 effectParam("ToPlayerID", "0");
	 effectParam("FromType", chooser);
	 effectParam("ToProto", "Arkantos God Out");
	if(bonusType=="unit") {
		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", bonusName);
		 effectParam("Count", ""+bonusAmount);
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", playerSpawnLoc(i));
	}
	else {
		for(j=0; <bonusAmount) {
			grantTechStr(i, bonusName);
		}
	}
	sendChat(coloredPlayerName(i)+" has been granted "+bonusDesc+" for "+kills+" kills!");
}

void addBonus(int kills=0, string chooser="") {		// other arguments implied from above.
	int id=0; int j=0;

	for(i=1; <cNumberPlayers) {
		id = rmCreateTrigger("bonus"+kills+"_p"+i+"_init");
		rmSwitchToTrigger(id);
		newCondition("Stat Value");
		 condParam("PlayerID", ""+i);
		 condParam("StatID", "2");	// units killed
		 condParam("Op", ">=");
		 condParam("Value", ""+kills);
		sendChat(coloredPlayerName(i)+" has "+kills+" kills!");
		newEffect("Sound Filename");
		 effectParam("Sound", "battlecry"+rmRandInt(1,4)+".wav");
		sendChatTo(i, "<color=0.9,0.5,0.0>Move the "+realName(chooser)+" on the corner island to choose a reward:</color>");
		sendChatTo(i, "<color=0.9,0.5,0.0>Arkantos:</color> "+bonusDesc1);
		sendChatTo(i, "<color=0.9,0.5,0.0>Athena:</color> "+bonusDesc2);
		sendChatTo(i, "<color=0.9,0.5,0.0>Gargarensis:</color> "+bonusDesc3);
		modifyProtoUnit("Hill Fort", 19, (HILLFORT_RAMPUP / cNumberPlayers)); // Increase repairing cost
		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", chooser);
		 effectParam("Count", "1");
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", pointLoc(0,0));
		newEffect("Flare Minimap");
		 effectParam("PlayerID", ""+i);
		 effectParam("Duration", "3.0");
		 effectParam("Position", pointLoc(0,0));
		newEffect("Quest Var Set");
		 effectParam("QVName", "can_choose_bonus_"+kills+"_p"+i);
		 effectParam("Value", "1");

		addBonusChoice(i, kills, chooser, bonusChoice1, bonusType1, bonusName1, bonusAmount1, bonusDesc1);
        addBonusChoice(i, kills, chooser, bonusChoice2, bonusType2, bonusName2, bonusAmount2, bonusDesc2);
		addBonusChoice(i, kills, chooser, bonusChoice3, bonusType3, bonusName3, bonusAmount3, bonusDesc3);

		// Create the kill info trigger
		id = rmCreateTrigger("info"+"_k"+kills+"_p"+i+"_init");
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		newCondition("Timer");
		condParam("Param1", "6");
		newCondition("Units In Area");
		condParam("Player", ""+i);
		condParam("DstObject", bonusFlag);
		condParam("UnitType", chooser);
		condParam("Op", ">=");
		condParam("Dist", "3.7");
		condParam("Count", "1");
		sendChatTo(i, "<color=0.9,0.5,0.0>Move the "+realName(chooser)+" on the corner island to choose a reward:</color>");
		sendChatTo(i, "<color=0.9,0.5,0.0>Arkantos:</color> "+bonusDesc1);
		sendChatTo(i, "<color=0.9,0.5,0.0>Athena:</color> "+bonusDesc2);
		sendChatTo(i, "<color=0.9,0.5,0.0>Gargarensis:</color> "+bonusDesc3);

	}
}


void addRampUnit(int cost=0, string name="", int mx=0, int mz=0, int rampAmount=0)
{
	int id=0;

	cost = cost * SB_SU_MULT;
	rampAmount = rampAmount * SB_SU_MULT;

	for(i=1; <cNumberPlayers) {

		// variable names
		string costVar = "p"+i+"_"+name+"_cost";

		// create the init trigger
		id = rmCreateTrigger("unit_"+name+"_p"+i+"_init");
		rmSwitchToTrigger(id);
		rmSetTriggerPriority(4);
		newEffect("Quest Var Set");
		 effectParam("QVName", costVar);
		 effectParam("Value", ""+cost);
		if (name == "Hero Norse")
		{
			modifyProtoUnitFor(i, name, 16, -40);   // gold cost
			modifyProtoUnitFor(i, name, 18, -80);   // food cost
		}
                if (name == "Hero Greek Bellerophon")
		{
			modifyProtoUnitFor(i, name, 16, -400);   // gold cost
			modifyProtoUnitFor(i, name, 19, -6);   // food cost
		}
                if (name == "Toxotes")
		{
			modifyProtoUnitFor(i, name, 16, -35);   // gold cost
			modifyProtoUnitFor(i, name, 17, -55);   // wood cost
		}
                if (name == "Archer Atlantean")
		{
			modifyProtoUnitFor(i, name, 16, -35);   // gold cost
			modifyProtoUnitFor(i, name, 17, -60);   // wood cost
		}
		modifyProtoUnitFor(i, name, 19, cost);   // favor cost

		// create the summoner object
		id = rmCreateObjectDef("unit_"+name+"_"+i);
		rmAddObjectDefItem(id, name, 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, offX(getSpecialX(i),mx), offZ(getSpecialZ(i),mz));


		// create the buy trigger
		id = rmCreateTrigger("unit_"+name+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		newCondition("Timer");
		 condParam("Param1", "3");
		newCondition("Player Resource Count");
		 condParam("PlayerID", ""+i);
		 condParam("Resource", "favor");
		 condParam("Op", ">=");
		 condParam("Count", "trQuestVarGet(\""+costVar+"\")");
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getStart(i));
		 condParam("UnitType", "Hill Fort");
		 condParam("Op", ">=");
		 condParam("Dist", "10.0");
		 condParam("Count", "1");
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getMonument(i));
		 condParam("UnitType", name);
		 condParam("Op", ">=");
		 condParam("Dist", "3.7");
		 condParam("Count", "1");
		newEffect("Grant Resources");
		 effectParam("PlayerID", ""+i);
		 effectParam("ResName", "favor");
		 effectParam("Amount", "0-trQuestVarGet(\""+costVar+"\")");
		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", name);
		 effectParam("Count", "1");
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", playerSpawnLoc(i));
		newEffect("Army Move");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("DstPoint", playerGatherLoc(i));
		 effectParam("AttackMove", "true");
		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", "Hero Death");
		 effectParam("Count", "1");
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", pointLoc(getSpecialX(i), getSpecialZ(i)));

		newEffect("Quest Var Modify");
		 effectParam("QVName", costVar);
		 effectParam("Oper", "+");
		 effectParam("Value", ""+rampAmount);

		modifyProtoUnitFor(i, name, 19, rampAmount);   // favor cost

		newCustomEffect("int newCost = trQuestVarGet(\""+costVar+"\");");


		sendChatTo(i, iconFavor+"Your "+name+" now costs <color=1.0,0.2,0.0>\"+newCost+\"</color> favor.");


	}
}


void addGarrisonUnit(int cost=0, string name="", int mx=0, int mz=0, int rampAmount=0)
{
	int id=0;

	for(i=1; <cNumberPlayers) {

		// variable names
		string costVar = "p"+i+"_garrison_cost";

		// create the init trigger
		id = rmCreateTrigger("unit_"+name+"_p"+i+"_init");
		rmSwitchToTrigger(id);
		rmSetTriggerPriority(4);
		newEffect("Quest Var Set");
		 effectParam("QVName", costVar);
		 effectParam("Value", ""+cost);
		modifyProtoUnitFor(i, name, 19, cost);   // favor cost

		// create the summoner object
		id = rmCreateObjectDef("unit_"+name+"_"+i);
		rmAddObjectDefItem(id, name, 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, offX(getSpecialX(i),mx), offZ(getSpecialZ(i),mz));


		// create the buy trigger
		id = rmCreateTrigger("unit_"+name+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		newCondition("Timer");
		 condParam("Param1", "3");
		newCondition("Player Resource Count");
		 condParam("PlayerID", ""+i);
		 condParam("Resource", "favor");
		 condParam("Op", ">=");
		 condParam("Count", "trQuestVarGet(\""+costVar+"\")");
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getStart(i));
		 condParam("UnitType", "Hill Fort");
		 condParam("Op", ">=");
		 condParam("Dist", "10.0");
		 condParam("Count", "1");
		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getMonument(i));
		 condParam("UnitType", name);
		 condParam("Op", ">=");
		 condParam("Dist", "3.7");
		 condParam("Count", "1");
		newEffect("Grant Resources");
		 effectParam("PlayerID", ""+i);
		 effectParam("ResName", "favor");
		 effectParam("Amount", "0-trQuestVarGet(\""+costVar+"\")");

		modifyProtoUnitFor(i, "Hill Fort", 5, 1); // Increase the garrison

		newEffect("Army Deploy");
		 effectParamArmy("SrcArmy", i, getArmy(i));
		 effectParam("ProtoName", "Hero Death");
		 effectParam("Count", "1");
		 effectParam("Heading", "0");
		 effectParam("Clear", "true");
		 effectParam("Location", pointLoc(getSpecialX(i), getSpecialZ(i)));

		newEffect("Quest Var Modify");
		 effectParam("QVName", costVar);
		 effectParam("Oper", "+");
		 effectParam("Value", ""+rampAmount);

		modifyProtoUnitFor(i, name, 19, rampAmount);   // favor cost

		newCustomEffect("int newCost = trQuestVarGet(\""+costVar+"\");");
		sendChatTo(i, iconFavor+"Your "+realName(name)+" now costs <color=1.0,0.2,0.0>\"+newCost+\"</color> favor.");


	}
}

void addCounterKills()
{
	int id=0;

	for(i=1; <cNumberPlayers)
	{
		// create the kills trigger
		id = rmCreateTrigger("kills_food_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		newCondition("Timer");
		 condParam("Param1", "5");
		newCustomEffect("int kills = trGetStatValue("+i+", 2);");
		newEffect("Grant Resources");
		 effectParam("PlayerID", ""+i);
		 effectParam("ResName", "food");
		 effectParam("Amount", "0-4999");
		newEffect("Grant Resources");
		 effectParam("PlayerID", ""+i);
		 effectParam("ResName", "food");
		 effectParam("Amount", "kills");
	}


}

// the bonus for killing a hillfort
void addBuildingKills()
{
	int id=0;
	int prod=0;

	for(i=1; <cNumberPlayers)
	{
		for (j=1; <7)
		{
			prod=420 * j; // 420 favor per 3 hersirs
			// create the kills trigger
			id = rmCreateTrigger("kills_buildings_p"+i+"_am_"+j);
			rmSwitchToTrigger(id);
			rmSetTriggerLoop(false);
			rmSetTriggerPriority(3);
			newCondition("Stat Value");
			 condParam("PlayerID", ""+i);
			 condParam("StatID", "5"); // 3 = buildings killed, 5 = buildings value killed
			 condParam("Op", ">=");
			 condParam("Value", ""+prod);
			newEffect("Army Deploy");
			 effectParamArmy("SrcArmy", i, getArmy(i));
			 effectParam("ProtoName", "Hero Norse");
			 effectParam("Count", "3");
			 effectParam("Heading", "0");
			 effectParam("Clear", "true");
			 effectParam("Location", playerSpawnLoc(i));
			newEffect("Army Move");
			 effectParamArmy("SrcArmy", i, getArmy(i));
			 effectParam("DstPoint", playerGatherLoc(i));
			 effectParam("AttackMove", "true");
			sendChat(coloredPlayerName(i)+" has recieved 3 Super Hersirs for Killing a Hillfort");
		}
	}

}

// Gives favor for controlling the spring - increases as the game goes on
void addSpringFavorBonuses(int i=0)
{
	int id=0;

	string questVar = "decaminutes";

	// create the init trigger (only for one of the players)
	if (i==1)
	{
		id = rmCreateTrigger("decaminutes_init_"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerPriority(4);
		newEffect("Quest Var Set");
		 effectParam("QVName", questVar);
		 effectParam("Value", "1");
    }

	// Create the favor giving trigger giving a favor every 30 / decaminutes seconds
	id = rmCreateTrigger("spring_favor_p"+i);
	rmSwitchToTrigger(id);
	rmSetTriggerLoop(true);
	rmSetTriggerPriority(4);
	newCondition("Timer");
	 condParam("Param1", "30 / trQuestVarGet(\""+questVar+"\")");
	newEffect("Grant Resources");
	 effectParam("PlayerID", ""+i);
	 effectParam("ResName", "favor");
	 effectParam("Amount", "trPlayerUnitCountSpecific("+i+", \"Healing Spring Object\")");



	// Now create the trigger that will increase decaminutes every 5 minutes
	// (only for one of the players)
	if (i==1)
	{
		id = rmCreateTrigger("spring_favor_deca_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(4);
		newCondition("Timer");
		 condParam("Param1", ""+SPRING_FAVOR_INC); // 600 = 10 minutes so 300 = 5 mins
		newEffect("Quest Var Modify");
		 effectParam("QVName", questVar);
		 effectParam("Oper", "+");
		 effectParam("Value", "1");
                 newCustomEffect("int seconds = 30 / trQuestVarGet(\""+questVar+"\");");
                 sendChat("<color=2.2,7.2,0.0>The Middle Spring Now Generates 1 Favor Every \"+seconds+\" Seconds");
                 newEffect("Message");
                 effectParam("Timeout", "14000");
	         effectParam("Text", "Norse Wars 7.1 by NW_Mike");
 }


}


// Gives win for controlling spring for X minutes
void addSpringWin(int i=0)
{
	int id=0;


	// The win
	int idwin = rmCreateTrigger("spring_winner_p"+i);
	rmSwitchToTrigger(idwin);
	rmSetTriggerLoop(false);
	rmSetTriggerActive(false);
	rmSetTriggerPriority(4);
	newEffect("Counter Stop");
	 effectParam("Name", "springwin" + i);
	newEffect("Set Player Won");
	 effectParam("Player", ""+i);


	// Getting the spring
	id = rmCreateTrigger("spring_win_p"+i);
	rmSwitchToTrigger(id);
	rmSetTriggerLoop(false);
	rmSetTriggerPriority(4);
	newCondition("Units In Area");
	 condParam("Player", ""+i);
	 condParam("DstObject", getStart(i));
	 condParam("UnitType", "Healing Spring Object");
	 condParam("Op", ">=");
	 condParam("Dist", "1000.0");
	 condParam("Count", "1");
	newEffect("Counter:Add Timer");
	 effectParam("Name", "springwin_"+i);
	 effectParam("Msg", coloredPlayerName(i) + " will WIN for controlling spring in");
	 effectParam("Start", ""+SEC_SPRING_WIN);
	 effectParam("Stop", "0");
	 effectParam("Event", ""+idwin);

	// losing the spring
	int id2 = rmCreateTrigger("spring_lose_p"+i);
	rmSwitchToTrigger(id2);
	rmSetTriggerLoop(true);
	rmSetTriggerPriority(4);
	newCondition("Units In Area");
	 condParam("Player", ""+i);
	 condParam("DstObject", getStart(i));
	 condParam("UnitType", "Healing Spring Object");
	 condParam("Op", "<");
	 condParam("Dist", "1000.0");
	 condParam("Count", "1");
	newEffect("Counter Stop");
	 effectParam("Name", "springwin_"+i);
	newEffect("Fire Event");
	 effectParam("EventID", ""+id);

}


void main(void)
{

	// map generation progress
	rmSetStatusText("",0.01);

	int i=0; int j=0; int k=0; int l=0; int id = 0; float sz = 0;
	float fx = 0; float fz = 0; float t = 0; float x=0; float z=0;
	string name1=""; string name2=""; string name3=""; string name4="";
	int nextMusicID = 0; int secondMusicID = 0; int lastMusicID = 0;

	// set size
	int playerTiles=0;
	int sizeX=0;
	int sizeZ=0;



	playerTiles=1200;
	sizeX=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles+23000);
	sizeZ=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles+23000);
	rmEchoInfo("Map size="+sizeX+"m x "+sizeZ+"m");
	rmSetMapSize(sizeX, sizeZ);

	// set sea level
	rmSetSeaLevel(0.0);

	// choose an environment
	env = rmRandInt(1, 6);


	// set map settings based on environment
	if(env==NORSE_ENV) {
		tBlack = "water";
		sSea = "Norwegian Sea";
		tPlayer = "norseRoadA";
		tConn = "norseRoadA";
		tMiddle = "snowGrass50";
		tStar = "underWaterRockC";
		tDecoPatch = chooseRand("snowGrass25", "snowGrass75");
		tForest = "Mixed Pine Forest";

		sLight = "default";

		sDeco1 = "Rock Granite Sprite";
		sDeco2 = "Rock River Icy";

		sFreeMU1 = "Shade of Hades";
		sFreeMU2 = chooseRand("Troll", "Einheriar");
		sFreeMU3 = chooseRand("Valkyrie", "Battle Boar", "Fernis Wolf");
		sFreeMU4 = chooseRand("Fire Giant", "Frost Giant", "Mountain Giant");

		sPower1 = chooseRand("Audrey", "Tremor", "vision");
		sPower1Caster = "Kastor Adult";
		sPower2 = chooseRand("Flaming Weapons", "Bronze");
		sPower2Caster = "Reginleif";

		sHero = chooseRand("Hero Greek Hippolyta", "Hero Greek Heracles");
		sMU1 = chooseRand("Valkyrie", "Einheriar", "Fenris Wolf");
		sMU2 = chooseRand("Frost Giant", "Fire Giant");
	}
	else if(env==GREEK_ENV) {
		tBlack = "water";
		sSea = "Mediterranean Sea";
		tPlayer = "greekRoadA";
		tConn = "greekRoadA";
		tMiddle = "grassA";
		tStar = "coralC";
		tDecoPatch = chooseRand("grassDirt50", "riverGrassyC");
		tForest = "Mixed Oak Forest";

		sLight = "default";

		sDeco1 = "Ruins";
		sDeco2 = "Flowers";

		sFreeMU1 = "Shade of Hades";
		sFreeMU2 = chooseRand("Centaur", "Minotaur");
		sFreeMU3 = chooseRand("Manticore", "Cyclops", "Nemean Lion");
		sFreeMU4 = chooseRand("Medusa", "Hydra");

		sPower1 = chooseRand("Tremor", "Audrey");
		sPower1Caster = "Kastor Adult";
		sPower2 = chooseRand("Bronze", "Flaming Weapons");
		sPower2Caster = "Ajax Older";

		sHero = chooseRand("Hero Greek Atalanta", "Hero Greek Odysseus");
		sMU1 = chooseRand("Minotaur", "Cyclops", "Centaur");
		sMU2 = chooseRand("Colossus", "Chimera");

		sCav4 = "Hetairoi";
		sInf3 = "Hoplite";
		sArc2 = "Peltast";
	}
	else if(env==EGYPTIAN_ENV) {
		tBlack = "water";
		sSea = "Red Sea";
		tPlayer = "egyptianRoadA";
		tConn = "egyptianRoadA";
		tMiddle = chooseRand4("sandA", "sandB", "sandC", "sandD");
		tStar = "coralE";
		tDecoPatch = chooseRand("riverSandyC", "sandDirt50");
		tForest = "Palm Forest";

		sLight = "default";

		sDeco1 = "Rock Sandstone Sprite";
		sDeco2 = "Rock Sandstone Small";

		sFreeMU1 = "Shade of Hades";
		sFreeMU2 = chooseRand("Wadjet", "Anubite", "Sphinx");
		sFreeMU3 = chooseRand("Scorpion Man", "Petsuchos");
		sFreeMU4 = chooseRand("Mummy", "Avenger");

		sPower1 = chooseRand("Serpents", "Tremor", "vision");
		sPower1Caster = "Kastor Adult";
		sPower2 = chooseRand("Meteor", "Tornado");
		sPower2Caster = "Setna";

		sHero = chooseRand("Priest");
		sMU1 = chooseRand("Sphinx", "Wadjet");
		sMU2 = chooseRand("Avenger", "Scarab");

		sInf4 = "Royal Guard";
		sInf2 = "Axeman";
		sCav2 = "Camelry";
		sArc4 = "Chariot Archer";
	}
	else if(env==HADES_ENV) {
		fBaseHeight = 7.5;
		tBlack = "hadesCliff";
		tCliff = "hadesCliff";
		tBlackPatch = "hades3";
		tBlackPatch2 = "hades4";
		sSea = "Mediterranean Sea";
		tPlayer = "hadesBuildable2";
		tConn = "hadesBuildable2";
		tMiddle = "hadesBuildable2";
		tStar = "underWaterRockE";
		tDecoPatch = chooseRand2("hades9", "hades9");
		tForest = "Hades Forest";

		sLight = "default";	// "erebus"

		sDeco1 = "Skeleton";
		sDeco2 = "Ruins";

		sFreeMU1 = "Shade of Hades";
		sFreeMU2 = chooseRand("Wadjet", "Promethean", "Troll");
		sFreeMU3 = chooseRand("Scorpion Man", "Dryad", "Manticore");
		sFreeMU4 = chooseRand("Mummy", "Medusa", "Heka Gigantes");

		sPower1 = chooseRand("Serpents", "Skeleton Power");
		sPower1Caster = "Kastor Adult";
		sPower2 = chooseRand("Meteor", "Bronze");
		sPower2Caster = "Theris";

		sHero = chooseRand("Hero Greek Chiron", "Hero Greek Heracles");
		sMU1 = chooseRand("Einheriar", "Automaton");
		sMU2 = chooseRand("Chimera", "Fire Giant");

		sInf3 = "Hoplite";
		sInf4 = "Royal Guard";
		sArc3 = "Archer Atlantean";
		sCav4 = "Hetairoi";
		sCav3 = "Lancer";
	}
	else if(env==TUNDRA_ENV) {
		tBlack = "water";
		sSea = "Tundra";
		tPlayer = "tundraRockA";
		tConn = "tundraRockA";
		tMiddle = "tundraGrassB";
		tStar = "coralF";
		tDecoPatch = chooseRand("tundraGrassA", "shorelineTundraD");
		tForest = "Tundra Forest";

		sLight = "default";

		sDeco1 = "Rock Granite Sprite";
		sDeco2 = "Rock Sandstone Big";

		sFreeMU1 = "Shade of Hades";
		sFreeMU2 = chooseRand("Troll", "Automaton");
		sFreeMU3 = chooseRand("Dryad", "Satyr", "Fenris Wolf");
		sFreeMU4 = chooseRand("Heka Gigantes", "Mountain Giant");

		sPower1 = chooseRand("Spiders", "Tremor");
		sPower1Caster = "Kastor Adult";
		sPower2 = chooseRand("Tornado", "Flaming Weapons");
		sPower2Caster = "Reginleif";

		sHero = chooseRand("Archer Atlantean Hero", "Lancer Hero");
		sMU1 = chooseRand("Fenris Wolf", "Troll", "Promethean");
		sMU2 = chooseRand("Mountain Giant", "Fire Giant", "Behemoth");

		sInf3 = "Swordsman";
		sInf4 = "Royal Guard";
		sArc3 = "Archer Atlantean";
		sCav3 = "Lancer";
		sArc2 = "Javelin Cavalry";
	}
	else if(env==MARSH_ENV) {
		tBlack = "water";
		sSea = "Marsh Pool";
		tPlayer = "marshB";
		tConn = "marshC";
		tMiddle = "marshB";
		tStar = "underwaterRockD";
		tDecoPatch = "marshC";
		tForest = "Marsh Forest";

		sLight = "default";

		sDeco1 = "Rotting Log";
		sDeco2 = "Rock River Sandy";

		sFreeMU1 = "Shade of Hades";
		sFreeMU2 = chooseRand("Promethean", "Wadjet");
		sFreeMU3 = chooseRand("Dryad", "Satyr");
		sFreeMU4 = chooseRand("Argus", "Heka Gigantes");

		sPower1 = chooseRand("Spiders", "vision");
		sPower1Caster = "Kastor Adult";
		sPower2 = chooseRand("Tornado", "Bronze");
		sPower2Caster = "Ajax Older";

		sHero = chooseRand("Archer Atlantean Hero", "Lancer Hero");
		sMU1 = chooseRand("Automaton");
		sMU2 = chooseRand("Behemoth", "Argus");

		sInf3 = "Swordsman";
		sInf4 = "Royal Guard";
		sArc3 = "Archer Atlantean";
		sCav3 = "Lancer";
		sArc2 = "Javelin Cavalry";
	}


	//SUPERBONUS settings ***************************
	string SBString="";

	int SB_HFHP = 14; // HillFort hit points (number of noseofsphinx upgrades)
	float SB_SR_MULT = 1.0;
	float SB_KB_MULT = 1.0;
	int bonusID = 0;
	int SB_Upgrades = 0;
	int SB_Lure_Count = 2;
	int SB_Rein_Time = 170;
	int SB_GP = 0;
	int SB_90H = 0;

	if (cMapSize == 1)
	{
		bonusID = rmRandInt(1, 30);

		if (bonusID == 1)
		{
			SBString = "#1: HillFort hit points = 7000";
			SB_HFHP = 0;
		}
		else if (bonusID == 2)
		{
			SBString = "#2: Control spring for 3 minutes to win";
			SEC_SPRING_WIN = 180;
		}
		else if (bonusID == 3)
		{
			SBString = "#3: Throwing Axemen have 40 range";
			id = rmCreateTrigger("SB_3TA");
			rmSwitchToTrigger(id);
			rmSetTriggerRunImmediately(true);
			newCondition("Timer");
			 condParam("Param1", "10");
			modifyProtoUnit("Throwing Axeman", 11, 31);
			modifyProtoUnit("Throwing Axeman", 2, 31);
		}
		else if (bonusID == 4)
		{
			SBString = "#4: Spring will increase favor bonus 5 times faster";
			SPRING_FAVOR_INC = 60;
		}
		else if (bonusID == 5)
		{
			SBString = "#5: HillFort hit points = 35,000";
			SB_HFHP = 33;
		}
		else if (bonusID == 6)
		{
			SBString = "#6: God powers are 50%% cheaper";
			SB_GP_MULT = 0.5;
		}
		else if (bonusID == 7)
		{
			SBString = "#7: Super Units are 60%% cheaper";
			SB_SU_MULT = 0.4;
		}
		else if (bonusID == 8)
		{
			SBString = "#8: HillFort attack is very strong";
			id = rmCreateTrigger("SB_8HF");
			rmSwitchToTrigger(id);
			rmSetTriggerRunImmediately(true);
			newCondition("Timer");
			 condParam("Param1", "10");
			modifyProtoUnit("Hill Fort", 31, 246);
			modifyProtoUnit("Hill Fort", 30, 246);
			modifyProtoUnit("Hill Fort", 27, 246);
			modifyProtoUnit("Hill Fort", 28, 246);

		}
		else if (bonusID == 9)
		{
			SBString = "#9: Everyone gets 1 favor every 2 seconds";
			for (i=1; <cNumberPlayers)
			{
				// create the kills trigger
				id = rmCreateTrigger("SB_9FF"+i);
				rmSwitchToTrigger(id);
				rmSetTriggerLoop(true);
				rmSetTriggerPriority(3);
				newCondition("Timer");
				 condParam("Param1", "2");
				newEffect("Grant Resources");
				 effectParam("PlayerID", ""+i);
				 effectParam("ResName", "favor");
		 		 effectParam("Amount", "1");
			 }

		}
		else if (bonusID == 10)
		{
			SBString = "#10: Free super archer every 30 seconds (if pop available)";
			// code in spawn area
		}
		else if (bonusID == 11)
		{
			SBString = "#11: Free super hersir every 30 seconds (if pop available)";
			// code in spawn area
		}
		else if (bonusID == 12)
		{
			SBString = "#12: Spawn rates doubled";
			SB_SR_MULT = 2.0;
		}
		else if (bonusID == 13)
		{
			SBString = "#13: Population limit = 260";
			POP_LIMIT = 260;
		}
		else if (bonusID == 14)
		{
			SBString = "#14: Kill Bonuses come twice as fast";
			SB_KB_MULT = 2.0;
		}
		else if (bonusID == 15)
		{
			SBString = "#15: No armor upgrades";
			SB_Upgrades = 1;
		}
		else if (bonusID == 16)
		{
			SBString = "#16: You get extra 5 towers - use them quickly!";
			SB_Lure_Count = 7;
		}
		else if (bonusID == 17)
		{
			SBString = "#17: No upgrade cost rampup or max";
			SB_maxup = 1;
			SB_Rampup = 0;
		}
		else if (bonusID == 18)
		{
			SBString = "#18: Reinforcements come every minute";
			SB_Rein_Time = 60;
		}
		else if (bonusID == 19)
		{
			SBString = "#19: Special, more frequent middle meteor";
			SB_GP = 1;
		}
		else if (bonusID == 20)
		{
			SBString = "#20: 96+ favor level will spawn heroes";
			SB_90H = 1;
		}
		else if (bonusID == 21)
		{
			SBString = "#21: Population limit = 120";
			POP_LIMIT = 120;
		}
		else if (bonusID == 22)
		{
			SBString = "#22: Myth Units have double speed, 75%% attack and 25%% faster recharge";
			id = rmCreateTrigger("SB_22MU");
			rmSwitchToTrigger(id);
			rmSetTriggerRunImmediately(true);
			newCondition("Timer");
			 condParam("Param1", "20");
			for (i=1; <cNumberPlayers)
			{
				// double speed
				grantTech(i, cTechThurisazRune);
				grantTech(i, cTechThurisazRune);
				grantTech(i, cTechThurisazRune);
				grantTech(i, cTechThurisazRune);
				grantTech(i, cTechThurisazRune);
				grantTech(i, cTechThurisazRune);
				grantTech(i, cTechThurisazRune);
				grantTech(i, cTechThurisazRune);

				// 25% faster special recharge
				grantTech(i, cTechRelicTailofCerberus);

				// 75% attack
				grantTech(i, cTechMonstrousRage);
				grantTech(i, cTechMonstrousRage);
				grantTech(i, cTechMonstrousRage);
			}

		}
		else if (bonusID == 23)
		{
			SBString = "#23: So far from home";
			SB_FFH = 1;
		}
		else if (bonusID == 24)
		{
			SBString = "#24: All free units have +5 speed";
			id = rmCreateTrigger("SB_24Speed");
			rmSwitchToTrigger(id);
			rmSetTriggerRunImmediately(true);
			newCondition("Timer");
			 condParam("Param1", "20");
			modifyProtoUnit(sInf1, 1, 5);
			modifyProtoUnit(sInf2, 1, 5);
			modifyProtoUnit(sInf3, 1, 5);
			modifyProtoUnit(sInf4, 1, 5);

			modifyProtoUnit(sCav1, 1, 5);
			modifyProtoUnit(sCav2, 1, 5);
			modifyProtoUnit(sCav3, 1, 5);
			modifyProtoUnit(sCav4, 1, 5);

			modifyProtoUnit(sArc1, 1, 5);
			modifyProtoUnit(sArc2, 1, 5);
			modifyProtoUnit(sArc3, 1, 5);
			modifyProtoUnit(sArc4, 1, 5);

			modifyProtoUnit(sFreeMU1, 1, 5);
			modifyProtoUnit(sFreeMU2, 1, 5);
			modifyProtoUnit(sFreeMU3, 1, 5);
			modifyProtoUnit(sFreeMU4, 1, 5);
		}
		else if (bonusID == 25)
		{
			SBString = "#25: Unit balance reversed - Infantry > Archers > Cavalry > Infantry";
			id = rmCreateTrigger("SB_25Counter");
			rmSwitchToTrigger(id);
			rmSetTriggerRunImmediately(true);
			newCondition("Timer");
			 condParam("Param1", "20");
			modifyProtoUnit(sInf1, 37, 3);
			modifyProtoUnit(sInf2, 37, 3);
			modifyProtoUnit(sInf3, 37, 3);
			modifyProtoUnit(sInf4, 37, 3);

			modifyProtoUnit(sCav1, 36, 3);
			modifyProtoUnit(sCav2, 36, 3);
			modifyProtoUnit(sCav3, 36, 3);
			modifyProtoUnit(sCav4, 36, 3);

			modifyProtoUnit(sArc1, 46, 3);
			modifyProtoUnit(sArc2, 46, 3);
			modifyProtoUnit(sArc3, 46, 3);
			modifyProtoUnit(sArc4, 46, 3);

			modifyProtoUnit(sFreeMU1, 34, 3);
			modifyProtoUnit(sFreeMU2, 34, 3);
			modifyProtoUnit(sFreeMU3, 34, 3);
			modifyProtoUnit(sFreeMU4, 34, 3);
		}
		else if (bonusID == 26)
		{
			SBString = "#26: Free siege spawns every 30 seconds (if pop available)";
		}
		else if (bonusID == 27)
		{
			SBString = "#27: Free Omniscience for everyone";

			id = rmCreateTrigger("SB_27O");
			rmSwitchToTrigger(id);
			rmSetTriggerRunImmediately(true);
			newCondition("Timer");
			 condParam("Param1", "31");
			for (i=1; <cNumberPlayers)
			{
				grantTech(i, cTechOmniscience);
			}
		}
		else if (bonusID == 28)
		{
			SBString = "#28: Wonder costs 200 food and 100 favor";
			id = rmCreateTrigger("SB_28Wonder");
			rmSwitchToTrigger(id);
			rmSetTriggerRunImmediately(true);
			newCondition("Timer");
			 condParam("Param1", "10");
			modifyProtoUnit("Wonder", 18, -800); // food cost
			modifyProtoUnit("Wonder", 19, 50); // favor cost
			modifyProtoUnit("Wonder", 16, -1000);
			modifyProtoUnit("Wonder", 17, -1000);
			modifyProtoUnit("Wonder", 0, -87990); // HP
			modifyProtoUnit("Wonder", 4, -150); // Build points
			modifyProtoUnit("Wonder", 2, -500); // Line of sight
		}
		else if (bonusID == 29)
		{

			SBString = "#29: All units -7 line of sight, no reinforcements";
			id = rmCreateTrigger("SB_29LOS");
			rmSwitchToTrigger(id);
			rmSetTriggerRunImmediately(true);
			newCondition("Timer");
			 condParam("Param1", "20");
			modifyProtoUnit(sInf1, 2, -7);
			modifyProtoUnit(sInf2, 2, -7);
			modifyProtoUnit(sInf3, 2, -7);
			modifyProtoUnit(sInf4, 2, -7);

			modifyProtoUnit(sCav1, 2, -7);
			modifyProtoUnit(sCav2, 2, -7);
			modifyProtoUnit(sCav3, 2, -7);
			modifyProtoUnit(sCav4, 2, -7);

			modifyProtoUnit(sArc1, 2, -7);
			modifyProtoUnit(sArc2, 2, -7);
			modifyProtoUnit("Toxotes", 2, -7);
			modifyProtoUnit("Archer Atlantean", 2, -7);
			modifyProtoUnit(sArc4, 2, -7);

			modifyProtoUnit(sFreeMU1, 2, -7);
			modifyProtoUnit(sFreeMU2, 2, -7);
			modifyProtoUnit(sFreeMU3, 2, -7);
			modifyProtoUnit(sFreeMU4, 2, -7);


			modifyProtoUnit(sHero, 2, -7);
			modifyProtoUnit(sMU1, 2, -7);
			modifyProtoUnit(sMU2, 2, -7);

			modifyProtoUnit("Hero Norse", 2, -7);
			modifyProtoUnit("Circe", 2, -7);
			modifyProtoUnit("Pharaoh", 2, -7);
			modifyProtoUnit("Hero Greek Bellerophon", 2, -7);

			modifyProtoUnit("Cataphract", 2, -7);
			modifyProtoUnit("Maceman", 2, -7);
			modifyProtoUnit("Raven", 2, -12);

			modifyProtoUnit("Tower", 2, -20);
			modifyProtoUnit("Hill Fort", 2, -7);

			SB_LOS = 1;

		}
		else if (bonusID == 30)
		{
			SBString = "#30: No superbonus this time! Regular game";
		}
	}

	iPower1Cost = getCost(sPower1);
	iPower2Cost = getCost(sPower2);
	iHeroCost = getCost(sHero);
	iMU1Cost = getCost(sMU1);
	iMU2Cost = getCost(sMU2);

	nFreeMU1 = realName(sFreeMU1);
	nFreeMU2 = realName(sFreeMU2);
	nFreeMU3 = realName(sFreeMU3);
	nFreeMU4 = realName(sFreeMU4);

	nArc1 = realName(sArc1);
	nArc2 = realName(sArc2);
	nArc3 = realName(sArc3);
	nArc4 = realName(sArc4);

	nCav1 = realName(sCav1);
	nCav2 = realName(sCav2);
	nCav3 = realName(sCav3);
	nCav4 = realName(sCav4);

	nInf1 = realName(sInf1);
	nInf2 = realName(sInf2);
	nInf3 = realName(sInf3);
	nInf4 = realName(sInf4);

	nMU1 = realName(sMU1);
	nMU2 = realName(sMU2);
	nHero = realName(sHero);

	nPower1 = realName(sPower1);
	nPower1Caster = realName(sPower1Caster);
	nPower2 = realName(sPower2);
	nPower2Caster = realName(sPower2Caster);

	// init map
	rmSetSeaType(sSea);
	rmTerrainInitialize(tBlack);
	rmSetLightingSet(sLight);
	rmSetGaiaCiv(cCivIsis);

	// map generation progress
	rmSetStatusText("",0.05);

	int clPlayer = rmDefineClass("clPlayer");
	int clMiddle = rmDefineClass("clMiddle");
	int clFountain = rmDefineClass("clFountain");
	int clDecoPatch = rmDefineClass("clDecoPatch");
	int clForest = rmDefineClass("clForest");
	int clBlackPatch2 = rmDefineClass("clBlackPatch");
	int clBonusIsland = rmDefineClass("clBonusIsland");
	int clExtraSpring = rmDefineClass("clExtraSpring");

	int cnsPlayers=rmCreateClassDistanceConstraint("avoidPlayers", clPlayer, 7);
	int cnsMiddle=rmCreateClassDistanceConstraint("avoidMiddle", clMiddle, 5);
	int cnsFountain=rmCreateClassDistanceConstraint("avoidFountain", clFountain, 7);
	int cnsForest=rmCreateClassDistanceConstraint("avoidForest", clForest, 7+cMapSize*2);
	int cnsExtraSpring=rmCreateClassDistanceConstraint("avoidExtraSpring", clExtraSpring, 4);
	int cnsEdge = rmCreateBoxConstraint("edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10),
		1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10));

	rmSetPlayerPlacementArea(0,0, 1,1);
	rmPlacePlayersCircular(0.47-rmXTilesToFraction(35),0.47-rmXTilesToFraction(35),rmDegreesToRadians(1));

	// map generation progress
	rmSetStatusText("",0.10);

	id = rmCreateArea("middle");
	rmAddAreaToClass(id, clMiddle);
	sz = (0.91-rmXTilesToFraction(94))*(0.91-rmXTilesToFraction(94))*PI/4;
	rmSetAreaSize(id, sz, sz);
	rmSetAreaTerrainType(id, tMiddle);
	rmSetAreaCoherence(id, 1);
	rmSetAreaLocation(id, 0.5, 0.5);
	rmSetAreaBaseHeight(id, fBaseHeight+0.5);
	rmSetAreaHeightBlend(id, 1);
	rmBuildArea(id);
	rmEchoInfo("Built middle area");

	id = rmCreateArea("fountainDummy");
	rmAddAreaToClass(id, clFountain);
	rmSetAreaSize(id, rmAreaTilesToFraction(200+cNumberPlayers*20), rmAreaTilesToFraction(200+cNumberPlayers*20));
	rmSetAreaTerrainType(id, tMiddle);
	rmSetAreaCoherence(id, 1);
	rmSetAreaLocation(id, 0.5, 0.5);
	rmSetAreaBaseHeight(id, fBaseHeight+0.5);
	rmSetAreaHeightBlend(id, 0);
	rmBuildArea(id);
	rmEchoInfo("Built fountain dummy area");

	// deco patches
	k = cNumberPlayers*3 + 2;
	k = k + rmRandInt(0-cNumberPlayers, cNumberPlayers);

	for(i=0; <k) {
		id = rmCreateArea("decoPatch"+i, rmAreaID("middle"));
		rmAddAreaToClass(id, clDecoPatch);
		rmSetAreaSize(id, rmAreaTilesToFraction(10), rmAreaTilesToFraction(40));
		rmSetAreaTerrainType(id, tDecoPatch);
		rmAddAreaConstraint(id, cnsFountain);
		rmSetAreaCoherence(id, 0);
		rmSetAreaBaseHeight(id, fBaseHeight+rmRandInt(5,15)/10.0*0.5);
		rmSetAreaHeightBlend(id, 1);
		rmBuildArea(id);
		rmEchoInfo("Built deco patch area "+i);
	}


	// forests
	k = cNumberPlayers*4 + 3;
	k = k + rmRandInt(0-cNumberPlayers/2, cNumberPlayers/2);
	for(i=0; <k) {
		id = rmCreateArea("forest"+i, rmAreaID("middle"));
		rmAddAreaToClass(id, clForest);

		rmSetAreaSize(id, rmAreaTilesToFraction(1), rmAreaTilesToFraction(10));

		rmSetAreaForestType(id, tForest);
		rmAddAreaConstraint(id, cnsFountain);
		rmAddAreaConstraint(id, cnsForest);
		rmAddAreaConstraint(id, cnsExtraSpring);
		rmSetAreaCoherence(id, 0);
		rmSetAreaBaseHeight(id, fBaseHeight+rmRandInt(5,15)/10.0*0.5);
		rmSetAreaHeightBlend(id, 1);
		rmBuildArea(id);
		rmEchoInfo("Built deco patch area "+i);
	}

	// player homes
	for(i=1; <cNumberPlayers) {
		id = rmCreateArea("player"+i);
		rmSetPlayerArea(i,id);
		rmAddAreaToClass(id, clPlayer);
		rmAddAreaConstraint(id, cnsMiddle);
		rmSetAreaSize(id, rmAreaTilesToFraction(480), rmAreaTilesToFraction(480));
		rmSetAreaTerrainType(id, tPlayer);
		rmSetAreaCoherence(id, 1);
		rmSetAreaLocPlayer(id, i);
		rmSetAreaBaseHeight(id, fBaseHeight+0.5);
		rmSetAreaHeightBlend(id, 1);
		rmBuildArea(id);
		rmEchoInfo("Built home area for player "+i);

		id = rmCreateConnection("connect"+i);
		rmAddConnectionArea(id, rmAreaID("player"+i));
		rmAddConnectionArea(id, rmAreaID("middle"));
		rmSetConnectionWidth(id, 28);
		if(tCliff!="") {rmSetConnectionWidth(id, 20);}
		rmSetConnectionBaseHeight(id, fBaseHeight+0.5);
		rmSetConnectionHeightBlend(id, 1);
		if(tBlackPatch!="") rmSetConnectionHeightBlend(id,0);
		rmAddConnectionTerrainReplacement(id, tBlack, tConn);
		rmAddConnectionTerrainReplacement(id, "blackRock", tConn);
		rmAddConnectionTerrainReplacement(id, "black", tConn);
		rmAddConnectionToClass(id, clPlayer);
		rmBuildConnection(id);
	}

	// fountain mound
	id = rmCreateArea("fountainMound");
	rmAddAreaToClass(id, clFountain);
	rmSetAreaSize(id, rmAreaTilesToFraction(310+cNumberPlayers*10), rmAreaTilesToFraction(310+cNumberPlayers*10));
	rmSetAreaTerrainType(id, tMiddle);
	rmSetAreaCoherence(id, 1);
	rmSetAreaLocation(id, 0.5, 0.5);
	rmSetAreaBaseHeight(id, fBaseHeight-2.5);
	rmSetAreaHeightBlend(id, 1);
	rmBuildArea(id);
	rmEchoInfo("Built fountain mound area");

	// map generation progress
	rmSetStatusText("",0.20);

	// store islands
	for(i=1; <cNumberPlayers) {
		id = rmCreateArea("store"+i);
		rmAddAreaToClass(id, clPlayer);
		x = (0.5 + rmXTilesToFraction(54))/0.5;
		z = (0.5 + rmZTilesToFraction(54))/0.5;
		setSpecialX(i, (rmPlayerLocXFraction(i)-0.5)*x+0.5);
		setSpecialZ(i, (rmPlayerLocZFraction(i)-0.5)*z+0.5);
		rmSetAreaLocation(id, getSpecialX(i), getSpecialZ(i));
		rmSetAreaSize(id, rmAreaTilesToFraction(155), rmAreaTilesToFraction(155));
		rmSetAreaTerrainType(id, tPlayer);
		rmSetAreaCoherence(id, 1);
		rmSetAreaBaseHeight(id, fBaseHeight+1.0);
		rmSetAreaHeightBlend(id, 1);
		rmBuildArea(id);
		rmEchoInfo("Built special area for player "+i);
	}

	// bonus island
	id = rmCreateArea("bonusIsland");
	rmAddAreaToClass(id, clBonusIsland);
	rmSetAreaLocation(id, 0.0, 0.0);
	rmSetAreaSize(id, rmAreaTilesToFraction(160), rmAreaTilesToFraction(160));
	rmSetAreaTerrainType(id, tPlayer);
	rmSetAreaCoherence(id, 1);
	rmSetAreaBaseHeight(id, fBaseHeight+1.0);
	rmSetAreaHeightBlend(id, 1);
	rmBuildArea(id);
	rmEchoInfo("Built bonus area");

	// map generation progress
	rmSetStatusText("",0.30);

	if(tBlackPatch != "") {
		for(i=1; <30) {
			id = rmCreateArea("blackPatch"+i,-1);
			rmSetAreaSize(id, 0.15, 0.2);
			rmSetAreaMinBlobs(id, 25);
			rmSetAreaMaxBlobs(id, 35);
			rmSetAreaMinBlobDistance(id, 0.0);
			rmSetAreaMaxBlobDistance(id, 55.1);
			rmAddAreaTerrainReplacement(id, tBlack, tBlackPatch);
			rmSetAreaCoherence(id, 0);
			rmAddAreaConstraint(id, cnsPlayers);
			rmAddAreaConstraint(id, cnsMiddle);
			rmBuildArea(id);
		}
		for(i=1; <300) {
			id = rmCreateArea("blackPatch2_"+i,-1);
			rmSetAreaSize(id, 0.0005, 0.001);
			rmAddAreaTerrainReplacement(id, tBlackPatch, tBlackPatch2);
			rmSetAreaCoherence(id, 0);
			rmAddAreaConstraint(id, cnsPlayers);
			rmAddAreaConstraint(id, cnsMiddle);
			rmAddAreaToClass(id, clBlackPatch2);
			rmBuildArea(id);
		}
	}

	rmBuildAllAreas();

	// map generation progress
	rmSetStatusText("",0.35);

	for(i=1; <cNumberPlayers) {
		rmSetPlayerResource(i, "food", 0);
		rmSetPlayerResource(i, "wood", 0);
		rmSetPlayerResource(i, "gold", 0);
		rmSetPlayerResource(i, "favor", 10);
	}

	for(i=1; <cNumberPlayers) {
		id=rmCreateObjectDef("home"+i);
		rmAddObjectDefItem(id, "Hill Fort", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		setHome(i, ""+rmGetUnitPlaced(id,0));

		id=rmCreateObjectDef("cameraStart"+i);
		rmAddObjectDefItem(id, "Camera Start", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		id=rmCreateObjectDef("startMarker"+i);
		rmAddObjectDefItem(id, "Revealer to Player", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		k=rmGetUnitPlaced(id,0);
		setStart(i, ""+k);

		k = rmRandInt(4,7);
		for(j=1; <k) {
			id=rmCreateObjectDef("decoWeapons"+i+"_"+j);
			rmAddObjectDefItem(id, "Weapons", 1, 0.0);
			rmSetObjectDefMinDistance(id, 4.0);
			rmSetObjectDefMaxDistance(id, 13.0);
			rmPlaceObjectDefAtLoc(id, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		}

		k = rmRandInt(1,1);
		for(j=1; <=k) {
			id=rmCreateObjectDef("decoGlow"+i+"_"+j);
			rmAddObjectDefItem(id, "Osiris Box Glow", 1, 0.0);
			rmSetObjectDefMinDistance(id, 0.0);
			rmSetObjectDefMaxDistance(id, 0.0);
			rmPlaceObjectDefAtLoc(id, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		}
	}

	for(i=1; <cNumberPlayers) {
		id=rmCreateObjectDef("monument"+i);
		rmAddObjectDefItem(id, "Monument 2", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, 0, getSpecialX(i), getSpecialZ(i));
		k=rmGetUnitPlaced(id,0);
		setMonument(i, ""+k);

		id=rmCreateObjectDef("chooser"+i);
		rmAddObjectDefItem(id, "Folstag Flag Bearer", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, offX(getSpecialX(i), -3), offZ(getSpecialZ(i), 0));
		k=rmGetUnitPlaced(id,0);
		setChooser(i, ""+k);
		changeNameTrigger(""+k, "Alfalfa");

		id=rmCreateObjectDef("arcUnit"+i);
		rmAddObjectDefItem(id, "Throwing Axeman", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, 0, offX(getSpecialX(i), -4), offZ(getSpecialZ(i), 3.5));
		k=rmGetUnitPlaced(id,0);
		setArcUnit(i, ""+k);

		id=rmCreateObjectDef("infUnit"+i);
		rmAddObjectDefItem(id, "Ulfsark", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, 0, offX(getSpecialX(i), -5), offZ(getSpecialZ(i), 0));
		k=rmGetUnitPlaced(id,0);
		setInfUnit(i, ""+k);

		id=rmCreateObjectDef("cavUnit"+i);
		rmAddObjectDefItem(id, "Raiding Cavalry", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, 0, offX(getSpecialX(i), -4), offZ(getSpecialZ(i), -3.5));
		k=rmGetUnitPlaced(id,0);
		setCavUnit(i, ""+k);
	}

	for(i=1; <cNumberPlayers) {
		setArmy(i, rmCreateArmy(i, "army"+i));
	}

	if(sBlackPatchDeco!="") {
		k = sqrt(cNumberPlayers)*iBlackPatchDecoAmount;
		k = k + rmRandInt(0-cNumberPlayers, cNumberPlayers);
		for(i=1; <k) {
			id=rmCreateObjectDef("blackPatchDeco_"+i);
			rmAddObjectDefItem(id, sBlackPatchDeco, 1, 0.0);
			rmSetObjectDefMinDistance(id, 0);
			rmSetObjectDefMaxDistance(id, rmXFractionToTiles(0.01));
			rmAddObjectDefConstraint(id, cnsPlayers);
			rmAddObjectDefConstraint(id, cnsMiddle);
			rmPlaceObjectDefInRandomAreaOfClass(id, 0, clBlackPatch2, 1);
		}
	}

	k = cNumberPlayers*3/2;
	k = k + rmRandInt(0-cNumberPlayers/2, cNumberPlayers/2);
	for(i=1; <k) {
		id=rmCreateObjectDef("deco1_"+i);
		rmAddObjectDefItem(id, sDeco1, 1, 0.0);
		rmSetObjectDefMinDistance(id, 15);
		rmSetObjectDefMaxDistance(id, rmXFractionToTiles(0.5));
		rmAddObjectDefConstraint(id, cnsPlayers);
		rmAddObjectDefConstraint(id, cnsFountain);
		rmAddObjectDefConstraint(id, cnsExtraSpring);
		rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5);
	}

	k = cNumberPlayers*3/2;
	k = k + rmRandInt(0-cNumberPlayers/2, cNumberPlayers/2);
	for(i=1; <k) {
		id=rmCreateObjectDef("deco2_"+i);
		rmAddObjectDefItem(id, sDeco2, 1, 0.0);
		rmSetObjectDefMinDistance(id, 15);
		rmSetObjectDefMaxDistance(id, rmXFractionToTiles(0.5));
		rmAddObjectDefConstraint(id, cnsPlayers);
		rmAddObjectDefConstraint(id, cnsFountain);
		rmAddObjectDefConstraint(id, cnsExtraSpring);
		rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5);
	}


	// central star
	float r1 = rmXTilesToFraction(9);
	float r2 = rmXTilesToFraction(3);
	float offset = rmRandFloat(0,2.0*PI);
	x = 0.0;
	while(x<5) {
		z = -0.5;
		while(z<=0.5) {
			createAreaLine(0.5+r1*cos(offset+ x/5.1*2*PI), 0.5+r1*sin(offset+ x/5.1*2*PI),
				0.5+r2*cos(offset+ (x+z)/5.1*2*PI), 0.5+r2*sin(offset+ (x+z)/5.1*2*PI),
				rmAreaTilesToFraction(15), tStar);
			z = z + 0.2;
		}

		x = x + 1.0;
	}
	rmBuildAllAreas();


	// bonus island
	id=rmCreateObjectDef("bonusMonument");
	rmAddObjectDefItem(id, "Monument 2", 1, 0.0);
	rmSetObjectDefMinDistance(id, 0.0);
	rmSetObjectDefMaxDistance(id, 0.0);
	rmPlaceObjectDefAtLoc(id, 0, rmXTilesToFraction(2), rmZTilesToFraction(2));
	k=rmGetUnitPlaced(id, 0);
	bonusMonument = ""+k;

	for(i=1; <cNumberPlayers) {
		id=rmCreateObjectDef("bonusRevealer"+i+"a");
		rmAddObjectDefItem(id, "Revealer To Player", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, rmXTilesToFraction(2), rmZTilesToFraction(8));
		id=rmCreateObjectDef("bonusRevealer"+i+"b");
		rmAddObjectDefItem(id, "Revealer To Player", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, rmXTilesToFraction(8), rmZTilesToFraction(2));
		id=rmCreateObjectDef("bonusRevealer"+i+"c");
		rmAddObjectDefItem(id, "Revealer To Player", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, rmXTilesToFraction(1), rmZTilesToFraction(1));
		id=rmCreateObjectDef("bonusRevealer"+i+"d");
		rmAddObjectDefItem(id, "Revealer To Player", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, rmXTilesToFraction(6), rmZTilesToFraction(6));
	}

	id=rmCreateObjectDef("bonusChoice1");
	rmAddObjectDefItem(id, "Arkantos God", 1, 0.0);
	rmSetObjectDefMinDistance(id, 0.0);
	rmSetObjectDefMaxDistance(id, 0.0);
	rmPlaceObjectDefAtLoc(id, 0, rmXTilesToFraction(1), rmZTilesToFraction(9));
	k=rmGetUnitPlaced(id,0);
	bonusChoice1 = ""+k;

	id=rmCreateObjectDef("bonusflag");
	rmAddObjectDefItem(id, "Flag", 1, 0.0);
	rmSetObjectDefMinDistance(id, 0.0);
	rmSetObjectDefMaxDistance(id, 0.0);
	rmPlaceObjectDefAtLoc(id, 0, rmXTilesToFraction(4), rmZTilesToFraction(4));
	k=rmGetUnitPlaced(id,0);
	bonusFlag = ""+k;

	id = rmCreateTrigger("heading_arkantos");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCustomEffect("trUnitSelectClear(); trUnitSelectByID("+k+"); trUnitSetHeading(180);");

	id=rmCreateObjectDef("bonusChoice2");
	rmAddObjectDefItem(id, "Athena", 1, 0.0);
	rmSetObjectDefMinDistance(id, 0.0);
	rmSetObjectDefMaxDistance(id, 0.0);
	rmPlaceObjectDefAtLoc(id, 0, rmXTilesToFraction(7), rmZTilesToFraction(7));
	k=rmGetUnitPlaced(id,0);
	bonusChoice2 = ""+k;

	id = rmCreateTrigger("heading_athena");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCustomEffect("trUnitSelectClear(); trUnitSelectByID("+k+"); trUnitSetHeading(225);");

	id=rmCreateObjectDef("bonusChoice3");
	rmAddObjectDefItem(id, "Gargarensis", 1, 0.0);
	rmSetObjectDefMinDistance(id, 0.0);
	rmSetObjectDefMaxDistance(id, 0.0);
	rmPlaceObjectDefAtLoc(id, 0, rmXTilesToFraction(9), rmZTilesToFraction(1));
	k=rmGetUnitPlaced(id,0);
	bonusChoice3 = ""+k;

	id = rmCreateTrigger("heading_kronos");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCustomEffect("trUnitSelectClear(); trUnitSelectByID("+k+"); trUnitSetHeading(270);");


	// map generation progress
	rmSetStatusText("",0.40);


	id = rmCreateTrigger("init_gaia1");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(5);
	if(env==NORSE_ENV || env==TUNDRA_ENV){
		newEffect("Render Snow");
		 effectParam("Percent", "0.15");
	}
	for(i=1; <cNumberPlayers) {
		newEffect("Player Kill All God Powers");
		 effectParam("Player", ""+i);
		newEffect("Unit Heading");
		 effectParam("SrcObject", ""+getInfUnit(i));
		 effectParam("Heading", "40");
		newEffect("Unit Heading");
		 effectParam("SrcObject", ""+getArcUnit(i));
		 effectParam("Heading", "40");
		newEffect("Unit Heading");
		 effectParam("SrcObject", ""+getCavUnit(i));
		 effectParam("Heading", "40");
		newEffect("Move to Unit");
		 effectParam("SrcObject", getChooser(i));
		 effectParam("DstObject", getInfUnit(i));
	}

	id = rmCreateTrigger("init_gaia2a");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	newCondition("Timer");
	 condParam("Param1", "4");
	newEffect("Grant God Power");
	 effectParam("PlayerID", "0");
	 effectParam("Count", "1");
	 effectParam("PowerName", "Vision");
	newEffect("Invoke God Power");
	 effectParam("PlayerID", "0");
	 effectParam("DstPoint1", pointLoc(0.5,0.5));
	 effectParam("PowerName", "Vision");

	id = rmCreateTrigger("init_gaia2b");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	newCondition("Timer");
	 condParam("Param1", "7");
	newEffect("Grant God Power");
	 effectParam("PlayerID", "0");
	 effectParam("Count", "1");
	 effectParam("PowerName", "Healing Spring");
	newEffect("Invoke God Power");
	 effectParam("PlayerID", "0");
	 effectParam("DstPoint1", pointLoc(0.5,0.5));
	 effectParam("PowerName", "Healing Spring");

	id = rmCreateTrigger("init_gaia2c");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	newCondition("Timer");
	 condParam("Param1", "12");
	// nothing...

	id = rmCreateTrigger("instructions1");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	newCondition("Timer");
	 condParam("Param1", "0");
	newEffect("Message");
	 effectParam("Timeout", "9000");
	 effectParam("Text", "Welcome to Norse Wars by Matei (7.1 by NW_Mike) Please read instructions here");
	newEffect("Sound Filename");
	 effectParam("Sound", "lightningstrike3.wav");

	id = rmCreateTrigger("instructions2");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	newCondition("Timer");
	 condParam("Param1", "8");
	newEffect("Message");
	 effectParam("Timeout", "9000");
	 effectParam("Text", "Protect your HILL FORT to survive, while trying to destroy the enemy Hill Forts.");
	for(i=1; <cNumberPlayers) {
		newEffect("Flare Minimap");
		 effectParam("PlayerID", ""+i);
		 effectParam("Duration", "3.0");
		 effectParam("Position", playerLoc(i));
	}

	id = rmCreateTrigger("instructions3");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	newCondition("Timer");
	 condParam("Param1", "16");
	newEffect("Message");
	 effectParam("Timeout", "9000");
	 effectParam("Text", "Soldiers spawn for free in your base based on your favor level."+" Use the FLAG BEARER on your island to choose unit type.");
	for(i=1; <cNumberPlayers) {
		newEffect("Flare Minimap");
		 effectParam("PlayerID", ""+i);
		 effectParam("Duration", "3.0");
		 effectParam("Position", playerGatherLoc(i));
	}
	sendChats(" ", " ", " ", " ", " ");
	sendChats(" ", " ", " ", " ", " ");
	sendChats(
	 "<color=0.4,0.85,0.85>FAVOR TO HOLD FOR AUTO-UNITS:</color>"+" 0, 25, 50, 75",
	 "<color=0.4,0.85,0.85>Infantry:</color> "+nInf1+", "+nInf2+", "+nInf3+", "+nInf4,
	 "<color=0.4,0.85,0.85>Archers:</color> "+nArc1+", "+nArc2+", "+nArc3+", "+nArc4,
	 "<color=0.4,0.85,0.85>Cavalry:</color> "+nCav1+", "+nCav2+", "+nCav3+", "+nCav4,
	 "<color=0.4,0.85,0.85>Free MU's:</color> "+nFreeMU1+", "+nFreeMU2+", "+nFreeMU3+", "+nFreeMU4
	);
	int gpMult=100; if(rmGetPlayerCiv(i)==cCivOdin) gpMult=88;
	sendChat("<color=0.4,0.85,0.85>Map God Powers:</color> "+nPower1Caster+"="+nPower1+"("+(iPower1Cost*gpMult/100)+
			 "), "+nPower2Caster+"="+nPower2+"("+(iPower2Cost*gpMult/100)+")");

	id = rmCreateTrigger("instructions4");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCondition("Timer");
	 condParam("Param1", "24");
	newEffect("Message");
	 effectParam("Timeout", "9000");
	 effectParam("Text", "Get favor by FIGHTING (only human units do this) or by holding center. "+"Use favor to REPAIR your fort (Norse infantry only).");
	for(i=1; <cNumberPlayers) {
		newEffect("Flare Minimap");
		 effectParam("PlayerID", ""+i);
		 effectParam("Duration", "3.0");
		 effectParam("Position", pointLoc(0.5, 0.5));
	}

	sendChat("<color=0.0,1.0,0.0>Your Food Amount Displays The Number of Units You've Killed</color>");
	sendChat("<color=0.0,1.0,0.0>Slingers, Peltasts and Turma have big bonuses vs heroes!</color>");


	id = rmCreateTrigger("instructions5");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCondition("Timer");
	 condParam("Param1", "32");
	newEffect("Message");
	 effectParam("Timeout", "9000");
	 effectParam("Text", "You can also use favor to PURCHASE god powers, upgrades and special units "+"on your store island.");
	for(i=1; <cNumberPlayers) {
		newEffect("Flare Minimap");
		 effectParam("PlayerID", ""+i);
		 effectParam("Duration", "3.0");
		 effectParam("Position", pointLoc(getSpecialX(i), getSpecialZ(i)));
	}
	sendChats(
	 "<color=0.4,0.85,0.85>CIV BONUSES:</color> (all decreased costs rounded downward)",
	 iconThor+"<color=0.4,0.85,0.85>Thor</color>:"+" Start with bronze armors; heroes +20%% HP; upgrades cost -7%%",
	 iconOdin+"<color=0.4,0.85,0.85>Odin</color>:"+" Free ravens; units +5%% HP; cav. 20%% faster; GP's cost -12%%",
	 iconLoki+"<color=0.4,0.85,0.85>Loki</color>:"+" MU's faster, cheaper, stronger; Inf +3 LOS; +4 bldg. +2 TA ",
	 "<color=0.4,0.85,0.85>UNIQUE UNITS</color>:"+" Thor=Drawf Decoy(4), Odin=Cataphract(3), Loki=Katapeltes(2)"
	);
	sendChat("<color=0.0,1.0,0.0>You can also click on a unit portrait to see its' favor cost (non myth)</color>");

	//SUPERBONUS text
	if (cMapSize == 1)
	{
		sendChat("<color=1.0,0.5,0.5>SUPERBONUS OF THE GAME </color>");
		sendChat("<color=1.0,0.0,0.0>" + SBString + " </color>");
		sendChat("<color=0.0,1.0,0.0>" + SBString + " </color>");
		sendChat("<color=1.0,0.5,0.5>SUPERBONUS OF THE GAME </color>");
	}


	id = rmCreateTrigger("instructions6");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCondition("Timer");
	 condParam("Param1", "40");
	newEffect("Message");
	 effectParam("Timeout", "9000");
	 effectParam("Text", "To see detailed costs for all units, powers and upgrades"+", move the THEOCRAT on your island to the monument.");


	id = rmCreateTrigger("instructions7");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCondition("Timer");
	 condParam("Param1", "48");
	newEffect("Message");
	 effectParam("Timeout", "9000");
	 effectParam("Text", "You will also recieve a choice of one of 3 free REWARDS"+" when you reach 100, 300, and multiples of 200 kills.");
	for(i=1; <cNumberPlayers) {
		newEffect("Flare Minimap");
		 effectParam("PlayerID", ""+i);
		 effectParam("Duration", "3.0");
		 effectParam("Position", pointLoc(0, 0));
	}

	id = rmCreateTrigger("instructions8");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCondition("Timer");
	 condParam("Param1", "56");
	newEffect("Sound Filename");
	 effectParam("Sound", "animalmagnetbirth.wav");
	newEffect("Message");
	 effectParam("Timeout", "9000");
	 effectParam("Text", "Finally, cast your LURE powers to place Towers. "+"The Lures will be removed at 2:20. Until then you can't buy god powers.");
	for(i=1; <cNumberPlayers) {
		newEffect("Grant God Power");
		 effectParam("PlayerID", ""+i);
		 effectParam("Count", ""+SB_Lure_Count);
		 effectParam("PowerName", "Animal Magnetism");
	}


	id = rmCreateTrigger("instructions9");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCondition("Timer");
	 condParam("Param1", "64");
	newEffect("Sound Filename");
	 effectParam("Sound", "battlecry"+rmRandInt(1,4)+".wav");
	newEffect("Message");
	 effectParam("Timeout", "9000");
	 effectParam("Text", chooseRand(
		chooseRand(
		"Now go forth to battle, and may the gods smile upon you!",
		"Now battle bravely and defeat your foes!",
		"Now fight valiantly, and may your deeds be remembered forever!" ),
		chooseRand(
		"Now fight worthily! (Well maybe not that worthily, you know)",
		"Now send your armies to war. May the gods be with you!",
		"Now go smite thy opponents! Good luck and have fun." )
	) );

	// map generation progress
	rmSetStatusText("",0.45);

	// map generation progress
	rmSetStatusText("",0.45);

	// diplomacy init
	for(i=1; <cNumberPlayers) {
		id = rmCreateTrigger("init_p"+i+"__diplo");
		rmSwitchToTrigger(id);
		rmSetTriggerRunImmediately(true);
		newEffect("Diplomacy");
		 effectParam("Status", "ally");
		 effectParam("Player1", ""+i);
		 effectParam("Player2", "0");
		newEffect("Diplomacy");
		 effectParam("Status", "neutral");
		 effectParam("Player1", "0");
		 effectParam("Player2", ""+i);
	}

	// starting techs, distributed over time to prevent lag


	for(i=0; <cNumberPlayers) {
		id = rmCreateTrigger("init_p"+i+"_a");
		rmSwitchToTrigger(id);
		rmSetTriggerRunImmediately(true);
		removeTech(i, cTechStartingResourcesEgyptian);
		removeTech(i, cTechStartingResourcesGreek);
		removeTech(i, cTechStartingResourcesNorse);
		grantTech(i, cTechAge2Heimdall);
		grantTech(i, cTechAge3Skadi);
		grantTech(i, cTechAge4Hel);
		newEffect("Player Kill All God Powers");
		 effectParam("Player", ""+i);
		grantTech(i, cTechSignalFires);
		grantTech(i, cTechSignalFires);
		grantTech(i, cTechCrenellations);
		for(j=1; <=22) {
			grantTech(i, cTechRelicArrowsofAlfar);
		}

		id = rmCreateTrigger("init_p"+i+"_c");
		rmSwitchToTrigger(id);
		newCondition("Timer");
		 condParam("Param1", "5");
		grantTech(i, cTechWatchTower);
		grantTech(i, cTechMediumArchers);
		grantTech(i, cTechHeavyArchers);
		grantTech(i, cTechChampionArchers);
		grantTech(i, cTechMediumInfantry);
		grantTech(i, cTechHeavyInfantry);
		grantTech(i, cTechChampionInfantry);
		grantTech(i, cTechMediumSlingers);
		grantTech(i, cTechHeavySlingers);
		grantTech(i, cTechChampionSlingers);
		grantTech(i, cTechMediumAxemen);
		grantTech(i, cTechHeavyAxemen);
		grantTech(i, cTechChampionAxemen);
		grantTech(i, cTechMediumSpearmen);
		grantTech(i, cTechHeavySpearmen);
		grantTech(i, cTechChampionSpearmen);

		id = rmCreateTrigger("init_p"+i+"_d");
		rmSwitchToTrigger(id);
		newCondition("Timer");
		 condParam("Param1", "6");
		grantTech(i, cTechSwineArray);
		grantTech(i, cTechHuntressAxe);
		grantTech(i, cTechLabyrinthofMinos);
		grantTech(i, cTechShoulderofTalos);
		grantTech(i, cTechFaceoftheGorgon);
		grantTech(i, cTechBurningPitch);
		grantTech(i, cTechFeetoftheJackal);
		grantTech(i, cTechFlamesofTyphon);
		grantTech(i, cTechCrocodopolis);
		grantTech(i, cTechAtefCrown);
		grantTech(i, cTechWillofKronos);

		id = rmCreateTrigger("init_p"+i+"_e");
		rmSwitchToTrigger(id);
		newCondition("Timer");
		 condParam("Param1", "8");
		//grantTech(i, cTechBoilingOil);
		grantTech(i, cTechHamarrtroll);
		grantTech(i, cTechAuroraBorealis);
		grantTech(i, cTechEldhrimnirKettle);
		grantTech(i, cTechRime);
		grantTech(i, cTechSylvanLore);
		grantTech(i, cTechCriosphinx);
		grantTech(i, cTechRoarofOrthus);
		grantTech(i, cTechSlingsoftheSun);
		grantTech(i, cTechVolcanicForge);
		grantTech(i, cTechHephaestusRevenge);
		grantTech(i, cTechIoGuardian);
		grantTech(i, cTechAlluvialClay);

		id = rmCreateTrigger("init_p"+i+"_f");
		rmSwitchToTrigger(id);
		newCondition("Timer");
		 condParam("Param1", "9");
		grantTech(i, cTechMediumCavalry);
		grantTech(i, cTechHeavyCavalry);
		grantTech(i, cTechChampionCavalry);
		grantTech(i, cTechHeavyCamelry);
		grantTech(i, cTechChampionCamelry);
		grantTech(i, cTechHeavyChariots);
		grantTech(i, cTechChampionChariots);
		grantTech(i, cTechHallofThanes);
		grantTech(i, cTechWeaponoftheTitans);
		grantTech(i, cTechFuneralRites);
		grantTech(i, cTechBiteOfTheShark);
		grantTech(i, cTechWeightlessMace);
		grantTech(i, cTechGemino);

		id = rmCreateTrigger("init_p"+i+"_g");
		rmSwitchToTrigger(id);
		newCondition("Timer");
		 condParam("Param1", "10");
		for(j=0; <=SB_HFHP) {
			grantTech(i, cTechRelicNoseoftheSphinx);
		}

		id = rmCreateTrigger("init_p"+i+"_h");
		rmSwitchToTrigger(id);
		newCondition("Timer");
		 condParam("Param1", "11");
		for(j=0; <=SB_HFHP) {
			grantTech(i, cTechRelicNoseoftheSphinx);
		}

		id = rmCreateTrigger("init_p"+i+"_i");
		rmSwitchToTrigger(id);
		newCondition("Timer");
		 condParam("Param1", "12");
		for(j=0; <=SB_HFHP) {
			grantTech(i, cTechRelicNoseoftheSphinx);
		}


		id = rmCreateTrigger("init_p"+i+"_j");
		rmSwitchToTrigger(id);
		newCondition("Timer");
		 condParam("Param1", "13");
		for(j=0; <=14) {
			grantTech(i, cTechMasons);
		}

		// bonus techs
		id = rmCreateTrigger("bonus_p"+i);
		rmSwitchToTrigger(id);
		newCondition("Timer");
		 condParam("Param1", "1");
		if(rmGetPlayerCiv(i)==cCivThor) {
			grantTech(i, cTechBronzeShields);
			grantTech(i, cTechBronzeMail);
			grantTech(i, cTechOlympicParentage);
			grantTech(i, cTechOlympicParentage);
			modifyProtoUnitFor(i, "Ulfsark", 27, 1); // Ulfsark Attack
		    rmSetPlayerResource(i, "favor", 15);

			modifyProtoUnitFor(i, "Dwarf", 25, 0.559); // Pierce Armour
			modifyProtoUnitFor(i, "Dwarf", 16, -60); //cost
			modifyProtoUnitFor(i, "Dwarf", 0, 125); // Hp Bonus
			modifyProtoUnitFor(i, "Dwarf", 1, 1.6); // Speed Boost
			modifyProtoUnitFor(i, "Dwarf", 2, -999); // LOS Removeal
			modifyProtoUnitFor(i, "Dwarf", 6, 1); // Pop+1


			modifyProtoUnitFor(i, "Hero Ragnorok", 6, 1); // Pop+1 for ragnarok


		}
		else if(rmGetPlayerCiv(i)==cCivOdin) {
			grantTech(i, cTechMythicRejuvenation);
			grantTech(i, cTechHeroicRenewal);
			grantTech(i, cTechRelicMithrilHorseshoes);
			grantTech(i, cTechRelicTuskoftheIronBoar);
			modifyProtoUnitFor(i, "Raiding Cavalry", 27, 3); // Raidng Cav hand attack hack
			modifyProtoUnitFor(i, "Cataphract", 24, 0.3);     // Cataphract Hack Armour
			modifyProtoUnitFor(i, "Cataphract", 25, -0.2);     // Cataphract Pierce Armour
			modifyProtoUnitFor(i, "Cataphract", 16, -70);
			modifyProtoUnitFor(i, "Cataphract", 18, -50);  // Cost
			modifyProtoUnitFor(i, "Cataphract", 1, 0.22);  // speed
			modifyProtoUnitFor(i, "Cataphract", 0, 50);      // Cataphract HP
			modifyProtoUnitFor(i, "Cataphract", 27, 10);     // Cataphract hand attack hack
 			modifyProtoUnitFor(i, "Lancer Hero", 0, 50);  // Hero Cav HP
		}
		else if(rmGetPlayerCiv(i)==cCivLoki) {
			grantTech(i, cTechThurisazRune);
			grantTech(i, cTechThurisazRune);
			grantTech(i, cTechRelicTailofCerberus);
			grantTech(i, cTechEyesintheForest);
			grantTech(i, cTechRelicTriosBow);
			grantTech(i, cTechRelicToothedArrows);
			grantTech(i, cTechRelicToothedArrows);
			modifyProtoUnitFor(i, "Throwing Axeman", 11, 2); // Throwing axemen range
			modifyProtoUnitFor(i, "Hill Fort", 11, 4);	// hill fort range
			modifyProtoUnitFor(i, "Tower", 11, 4);		// tower range
			modifyProtoUnitFor(i, "Shade of Hades", 1, 1);	// shade speed
			modifyProtoUnitFor(i, "Shade of Hades", 27, 5);	// shade hand attack hack
			modifyProtoUnitFor(i, "Throwing Axeman", 27, 1.5); // Throwing axemen attack
			modifyProtoUnitFor(i, "Maceman", 16, -35);     //
			modifyProtoUnitFor(i, "Maceman", 18, -60);     //  cost
			modifyProtoUnitFor(i, "Maceman", 24, -0.14); // Hack Armour
			modifyProtoUnitFor(i, "Maceman", 25, 0.1); // Pierce Armour
			modifyProtoUnitFor(i, "Maceman", 27, 2); // Hack Attack
			modifyProtoUnitFor(i, "Maceman", 1, 1.05); // Speed
			modifyProtoUnitFor(i, "Maceman", 0, 34); // hp
		}
	}

	// map generation progress
	rmSetStatusText("",0.50);

	for(i=1; <cNumberPlayers) {
		if(rmGetPlayerCulture(i)!=cCultureNorse) {
			id = rmCreateTrigger("warnCulture_p"+i);
			rmSwitchToTrigger(id);
			newCondition("Timer");
			 condParam("Param1", "18");
			sendChat(coloredPlayerName(i)+"<color=0.7,0.7,0.7>, you can't"+" gain Favor since you aren't Norse!</color>");
			sendChat(chooseRand(
				"<color=0.7,0.7,0.7>An unwise choice on a map called"+" NORSE Wars, don't you think?</color>",
				"<color=0.7,0.7,0.7>Please don't blame me if you die"+" in 5 minutes.</color>",
				"<color=0.7,0.7,0.7>Worship Odin, Loki and"+" Thor next time, or they'll be angry!</color>",
				"<color=0.7,0.7,0.7>I guess I should've called the "+"map just 'Norse'.</color>",
			));
		}
	}

	for(i=1; <cNumberPlayers) {
		id = rmCreateTrigger("lost_p"+i);
		rmSwitchToTrigger(id);

		newCondition("Units In Area");
		 condParam("Player", ""+i);
		 condParam("DstObject", getStart(i));
		 condParam("UnitType", "Hill Fort");
		 condParam("Op", "<");
		 condParam("Dist", "10.0");
		 condParam("Count", "1");
		sendChat(coloredPlayerName(i)+"<color=0.7,0.7,0.7> has been defeated!</color>", 0);
		newEffect("Sound Filename");
		 effectParam("Sound", "cinematics\35_out\no.mp3");
		newEffect("Sound Filename");
		 effectParam("Sound", "\cinematics\35_out\wholestatuefall.mp3");
		newEffect("Set Player Defeated");
		 effectParam("Player", ""+i);

		id = rmCreateTrigger("resigned_p"+i);
		rmSwitchToTrigger(id);
		newCondition("Player Defeated");
		 condParam("PlayerID", ""+i);
		newEffect("Kill");
		 effectParam("SrcObject", ""+getHome(i));

		id = rmCreateTrigger("remove_lures_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerPriority(4);
		newCondition("Timer");
		 condParam("Param1", ""+LURE_END_TIME);
		newEffect("Player Kill All God Powers");
		 effectParam("Player", ""+i);

		id = rmCreateTrigger("lures_to_towers_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		newCondition("Player Unit Count");
		 condParam("PlayerID", ""+i);
		 condParam("ProtoUnit", "Animal Attractor");
		 condParam("Op", ">=");
		 condParam("Count", "1");
		newEffect("Change Units In Area");
		 effectParam("SrcObject", bonusMonument);
		 effectParam("Dist", "2000");
		 effectParam("FromPlayerID", ""+i);
		 effectParam("ToPlayerID", ""+i);
		 effectParam("FromType", "Animal Attractor");
		 effectParam("ToProto", "Tower");

		id = rmCreateTrigger("pigs_to_dust_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		newCondition("Player Unit Count");
		 condParam("PlayerID", ""+i);
		 condParam("ProtoUnit", "Pig");
		 condParam("Op", ">=");
		 condParam("Count", "1");
		newEffect("Change Units In Area");
		 effectParam("SrcObject", bonusMonument);
		 effectParam("Dist", "2000");
		 effectParam("FromPlayerID", ""+i);
		 effectParam("ToPlayerID", ""+i);
		 effectParam("FromType", "Pig");
		 effectParam("ToProto", "Dust Medium");

		 // forbid building towers
		id = rmCreateTrigger("forbid_towers_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerPriority(3);
		newEffect("Forbid and Disable Unit");
		 effectParam("PlayerID", ""+i);
		 effectParam("ProtoUnit", "Tower");

		addSpringFavorBonuses(i);
		addSpringWin(i);
	}


	id = rmCreateTrigger("remove_lures_warning1");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCondition("Timer");
	 condParam("Param1", ""+(LURE_END_TIME-50));
	sendChat("<color=1.0,0.2,0.0>50 SECONDS LEFT TO CAST LURES</color>");
	newEffect("Sound Filename");
	 effectParam("Sound", "animalmagnetbirth.wav");

	id = rmCreateTrigger("remove_lures_warning2");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCondition("Timer");
	 condParam("Param1", ""+(LURE_END_TIME-30));
	sendChat("<color=1.0,0.2,0.0>30 SECONDS LEFT TO CAST LURES</color>");
	newEffect("Sound Filename");
	 effectParam("Sound", "animalmagnetbirth.wav");

	id = rmCreateTrigger("remove_lures_warning3");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCondition("Timer");
	 condParam("Param1", ""+(LURE_END_TIME-10));
	sendChat("<color=1.0,0.2,0.0>10 SECONDS LEFT TO CAST LURES</color>");
	newEffect("Sound Filename");
	 effectParam("Sound", "animalmagnetbirth.wav");

	id = rmCreateTrigger("remove_lures_warning4");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	newCondition("Timer");
	 condParam("Param1", ""+LURE_END_TIME);
	sendChat("<color=1.0,0.2,0.0>LURE POWERS REMOVED</color>");
	sendChat("<color=0.2,0.8,0.2>YOU CAN NOW BUY YOUR OWN GOD POWERS</color>");
	newEffect("Sound Filename");
	 effectParam("Sound", "lightningstrike3.wav");



	// modify protounits for balance ****************************

	id = rmCreateTrigger("modify_protounits");
	rmSwitchToTrigger(id);
	rmSetTriggerRunImmediately(true);
	modifyProtoUnit("Hill Fort", 16, -250);	 // HF gold cost
	modifyProtoUnit("Hill Fort", 17, -250);  // HF wood cost
	modifyProtoUnit("Hill Fort", 19, HILLFORT_START - 5);   // HF favor cost
	modifyProtoUnit("Hill Fort", 5, -10);	 // HF garison capacity (starts at 0)
	modifyProtoUnit("Hill Fort", 4, 200);	 // HF repair points (long to repair)
	modifyProtoUnit("Tower", 16, -100);  // Tower gold cost
	modifyProtoUnit("Tower", 17, -200);  // Tower wood cost
	modifyProtoUnit("Tower", 19, 45);    // Tower favor cost
	modifyProtoUnit("Tower", 4, 100);    // Tower repair points (long to repair)

	modifyProtoUnit("Hill Fort", 12, -10);	 // Minimum range
	modifyProtoUnit("Tower", 12, -10);	 // Minimum range

	modifyProtoUnit("Hill Fort", 28, 25);	 // HF hand attack pierce (boiling oil)

	modifyProtoUnit("Dryad", 6, 3);   // Dryad Pop
	modifyProtoUnit("Dryad", 1, 0.5);   // Dryad speed
	modifyProtoUnit("Dryad", 27, 10);   // Dryad hand attack
	modifyProtoUnit("Dryad", 0, 100);   // Dryad HP

	modifyProtoUnit("Audrey", 0, 2100);	 // Carnivora HP
	modifyProtoUnit("Audrey", 9, -20);	 // Carnivora recharge time
	modifyProtoUnit("Serpent", 0, 170);	 // Serpent HP
	modifyProtoUnit("Serpent", 27, 12);	 // Serpent attack
	modifyProtoUnit("Shade of Hades", 0, 33);// Shade HP
	modifyProtoUnit("Shade of Hades", 1, 1); // Shade speed
	modifyProtoUnit("Shade of Hades", 27, 5);// Shade attack
	modifyProtoUnit("Automaton", 1, 0.5); 	 // Automaton speed
	modifyProtoUnit("Colossus", 1, 0.5); 	 // Colossus speed
	modifyProtoUnit("Wadjet", 1, 0.5); 	 // Wadjet speed
	modifyProtoUnit("Troll", 1, 0.5); 	 // Troll speed
	modifyProtoUnit("Minotaur", 1, 0.5); 	 // Minotaur speed
	modifyProtoUnit("Mountain Giant", 1, 0.5); // Mountain Giant speed
	modifyProtoUnit("Cyclops", 1, 0.5); 	 // Cyclops speed
	modifyProtoUnit("Einheriar", 1, 0.5); 	 // Einherjar speed
	modifyProtoUnit("Folstag Flag Bearer", 1, -2); // Flag Bearer speed
	modifyProtoUnit("Hetairoi", 41, -1.75);  // Hetairoi bonus vs buildings (starts at 3.5)
	modifyProtoUnit("Hetairoi", 0, 80);  // Hetairoi HP
	modifyProtoUnit("Lancer Hero", 0, 7);  // Hero contarius HP
	modifyProtoUnit("Lancer Hero", 6, -1);  // Hero contarius Pop
	modifyProtoUnit("Archer Atlantean Hero", 6, -1);  // Hero Arcus Pop
	modifyProtoUnit("Archer Atlantean Hero", 0, -35);  // Hero Arcus Hp
	modifyProtoUnit("Archer Atlantean Hero", 25, 0.2);  // Pierce armor
	modifyProtoUnit("Archer Atlantean Hero", 31, 2);  // Hero Arcus Attack
	modifyProtoUnit("Archer Atlantean Hero", 16, -60);
	modifyProtoUnit("Archer Atlantean Hero", 17, -100);   // Cost

	modifyProtoUnit("Lancer Hero", 18, -125);
	modifyProtoUnit("Lancer Hero", 16, -70);  // Cost
	modifyProtoUnit("Royal Guard Hero", 18, -135);
	modifyProtoUnit("Royal Guard Hero", 16, -100);  // gold Cost
	modifyProtoUnit("Royal Guard Hero", 19, 3);  // favor Cost
	modifyProtoUnit("Swordsman Hero", 6, -1);  //
	modifyProtoUnit("Royal Guard Hero", 6, -1);  //
	modifyProtoUnit("Javelin Cavalry Hero", 6, -1);
	modifyProtoUnit("Javelin Cavalry Hero", 17, -90);
	modifyProtoUnit("Javelin Cavalry Hero", 16, -75);  // gold Cost
	modifyProtoUnit("Swordsman Hero", 18, -100);
	modifyProtoUnit("Swordsman Hero", 16, -55);  // gold Cost
	modifyProtoUnit("Swordsman Hero", 19, 1);  // favor Cost

	modifyProtoUnit("Circe", 0, 300);	 // Circe HP
	modifyProtoUnit("Circe", 6, -2);	 // Circe Pop
	modifyProtoUnit("Circe", 1, 1.3);   // Circe speed

	modifyProtoUnit("Hero Norse", 1, 4.0);   // Hersir speed
	modifyProtoUnit("Hero Norse", 0, 218);   // Hersir HP
	modifyProtoUnit("Hero Norse", 27, 50);   // Hersir hack attack
	modifyProtoUnit("Hero Norse", 6, -1);   // Hesir Pop
	modifyProtoUnit("Titan Atlantean", 0, 1);   // Titan HP
	modifyProtoUnit("Titan Atlantean", 6, -20);   // Titan Pop
	modifyProtoUnit("Hero Greek Bellerophon", 6, -4);   // Bell Pop
	modifyProtoUnit("Pharaoh", 0, 70);   // Pharaoh HP
	modifyProtoUnit("Pharaoh", 1, 1.3);   // Pharaoh speed
	modifyProtoUnit("Pharaoh of Osiris", 0, -45.5);   // SOO HP
	modifyProtoUnit("Pharaoh of Osiris", 1, -0.6);   // SOO speed
	modifyProtoUnit("Pharaoh of Osiris", 34, 1.5);   // SOO hero bonus
	modifyProtoUnit("Pharaoh", 34, 2.5);   // Pharaoh hero bonus

	// Island units higher HP
	modifyProtoUnit("Folstag Flag Bearer", 0, 500);
	modifyProtoUnit("Female", 0, 300);
	modifyProtoUnit("Skult", 0, 300);
	modifyProtoUnit("Brokk", 0, 300);
	modifyProtoUnit("Eitri", 0, 300);
	modifyProtoUnit("Shaba Ka", 0, 300);
	modifyProtoUnit("Scout", 0, 300);

	modifyProtoUnit("Hero Greek Bellerophon", 0, 150); // Bellerophon HP
	modifyProtoUnit("Hero Greek Bellerophon", 1, 3.0); // Bellerophon speed
	modifyProtoUnit("Hero Greek Bellerophon", 27, 50); // Bellerophon hack attack
	modifyProtoUnit("Hero Greek Polyphemus", 0, 9000); // poly hp
	modifyProtoUnit("Hero Greek Polyphemus", 9, -10); // poly recharge
	modifyProtoUnit("Hero Greek Polyphemus", 24, 0.3); // poly hack armour
	modifyProtoUnit("Hero Greek Polyphemus", 25, 0.3); // poly pierce armour
	modifyProtoUnit("Archer Atlantean Hero", 24, 0.15); // Loki reinforcement hack armour
	modifyProtoUnit("Archer Atlantean Hero", 25, 0.15); // Loki reinforcement pierce armour
	modifyProtoUnit("Lancer Hero", 24, 0.15); // Odins reinforcemetn hack armour
	modifyProtoUnit("Lancer Hero", 25, 0.15); // Odins reinforcement pierce armor
	modifyProtoUnit("Hero Greek Polyphemus", 27, 480); // poly hack attack
	modifyProtoUnit("Hero Greek Polyphemus", 28, 500); // poly pirece attack
	modifyProtoUnit("Hero Greek Polyphemus", 29, 245); // poly crush attack

	modifyProtoUnit("Forkboy", 27, -900);             // Forkboy hack attack
	modifyProtoUnit("Mercenary Cavalry", 27, -900);   // Mer Cav hack attack
    modifyProtoUnit("Mercenary Cavalry", 8, 20000);   // Merc Cav lifespan
    modifyProtoUnit("Catapult", 1, 2.0);       // Catapult speed
    modifyProtoUnit("Catapult", 32, 50);       // Catapult ranged attack crush
    modifyProtoUnit("Maceman", 27, 6);	   // Katapeltes hand attack hack
 	modifyProtoUnit("Heka Gigantes", 0, -350);	   // Heka Gigantes -350 HP
 	modifyProtoUnit("Archer Atlantean Hero", 0, 24); // Arcus Hero +24 HP
 	modifyProtoUnit("Archer Atlantean", 1, 0.25); // Arcus +0.25 speed
 	modifyProtoUnit("Archer Atlantean Hero", 1, 0.45); // Arcus Hero +0.15 speed
 	modifyProtoUnit("Archer Atlantean Hero", 32, 1); // Arcus Hero +1 Chrush
 	modifyProtoUnit("Chariot Archer", 32, 4);
 	modifyProtoUnit("Hero Ragnorok", 0, -36); // Thor Ragnarocks -36 HP
    modifyProtoUnit("Hero Ragnorok", 1, -0.8); // Thor Ragnarocks -0.8 Speed
 	modifyProtoUnit("Caravan Atlantean", 0, 1000); //
 	modifyProtoUnit("Caravan Greek", 0, 1000); //
 	modifyProtoUnit("Caravan Norse", 0, 1000); //
 	modifyProtoUnit("Caravan Egyptian", 0, 1000); //
 	modifyProtoUnit("Old Man", 0, 1000); //

 	modifyProtoUnit("Meteor", 29, -500); // Meteor -crush
 	modifyProtoUnit("Meteor", 27, 50); // Meteor +hack
 	modifyProtoUnit("Tornado", 29, -500); // Tornado -crush
 	modifyProtoUnit("Tornado", 27, 50); // Tornado -crush

 	// island bonus units more HP
 	modifyProtoUnit("Caravan Atlantean", 0, 1000); //
	modifyProtoUnit("Caravan Greek", 0, 1000); //
	modifyProtoUnit("Caravan Norse", 0, 1000); //
	modifyProtoUnit("Caravan Egyptian", 0, 1000); //
 	modifyProtoUnit("Old Man", 0, 1000); //


	// slingers counter heroes
 	modifyProtoUnit("Slinger", 45, 6); // Range bonus vs heroes
 	modifyProtoUnit("Peltast", 45, 6); // Range bonus vs heroes
 	modifyProtoUnit("Javelin Cavalry", 45, 6); // Range bonus vs heroes


 	modifyProtoUnit("Throwing Axeman", 46, -0.4); // TA weaker vs cavalry


	// Cavalry more pierce armor
 	modifyProtoUnit("Raiding Cavalry", 25, 0.15); // Pierce Armour
 	modifyProtoUnit("Prodromos", 25, 0.2); // Pierce Armour
 	modifyProtoUnit("Hippikon", 25, 0.15); // Pierce Armour
 	modifyProtoUnit("Hetairoi", 25, 0.15); // Pierce Armour
 	modifyProtoUnit("Camelry", 25, 0.2); // Pierce Armour
 	modifyProtoUnit("Jarl", 25, 0.15); // Pierce Armour
 	modifyProtoUnit("Lancer", 25, 0.15); // Pierce Armour



	//SUPER ARCHER TOX RANGE BONUS
	if (sArc3 == "Archer Atlantean") {
		 modifyProtoUnit("Toxotes", 11, 2); // Super archer + 2 Range

	}
	// map generation progress
	rmSetStatusText("",0.55);


	addRavens(30);

	if (SB_LOS == 0)
		addReinforcements(SB_Rein_Time);

	if (SB_GP == 0)
		addGaiaPower("Meteor", 245);
	else if (SB_GP == 1)
		addGaiaPower("chicken storm", 100);

	addSpawningUnit(sInf1, 1, 2 / SB_SR_MULT, 0,24, "inf");
	addSpawningUnit(sInf2, 1, 2 / SB_SR_MULT, 25,49, "inf");
	addSpawningUnit(sInf3, 1, 1.7 / SB_SR_MULT, 50,74, "inf");
	if (SB_90H == 0)
		addSpawningUnit(sInf4, 1, 2 / SB_SR_MULT, 75,100, "inf");
	else if (SB_90H == 1)
	{
		addSpawningUnit(sInf4, 1, 2 / SB_SR_MULT, 75,95, "inf");
		addSpawningUnit("Hero Greek Atalanta", 1, 3, 96,100, "inf");
	}


	addSpawningUnit(sArc1, 1, 2 / SB_SR_MULT, 0,24, "arc");
	addSpawningUnit(sArc2, 1, 1.9 / SB_SR_MULT, 25,49, "arc");
	addSpawningUnit(sArc3, 1, 1.7 / SB_SR_MULT, 50,74, "arc");
	if (SB_90H == 0)
		addSpawningUnit(sArc4, 1, 2 / SB_SR_MULT, 75,100, "arc");
	else if (SB_90H == 1)
	{
		addSpawningUnit(sArc4, 1, 2 / SB_SR_MULT, 75,95, "arc");
		addSpawningUnit("Hero Greek Odysseus", 1, 3, 96,100, "arc");
	}


	addSpawningUnit(sCav1, 1, 2.2 / SB_SR_MULT, 0,24, "cav");
	addSpawningUnit(sCav2, 1, 2 / SB_SR_MULT, 25,49, "cav");
	addSpawningUnit(sCav3, 1, 1.8 / SB_SR_MULT, 50,74, "cav");
	if (SB_90H == 0)
		addSpawningUnit(sCav4, 1, 2.2 / SB_SR_MULT, 75,100, "cav");
	else if (SB_90H == 1)
	{
		addSpawningUnit(sCav4, 1, 2.2 / SB_SR_MULT, 75,95, "cav");
		addSpawningUnit("Hero Greek Achilles", 1, 3.5, 96,100, "cav");
	}

	addSpawningUnit(sFreeMU1, 1, 12 / SB_SR_MULT, 0,24);
	addSpawningUnit(sFreeMU2, 1, 13 / SB_SR_MULT, 25,49);
	addSpawningUnit(sFreeMU3, 1, 14 / SB_SR_MULT, 50,74);
	addSpawningUnit(sFreeMU4, 1, 16 / SB_SR_MULT, 75,100);


	// Superbonus 10, 11 and 26
	if (bonusID == 10)
	{
		SBString = "#10: Free super archer every 30 seconds (if pop available)";
		if (sArc3 == "Archer Atlantean") {
			addSpawningUnit("Toxotes", 1, 30, 1, 100);
		}
		else {
			addSpawningUnit("Archer Atlantean", 1, 30, 1, 100);
		}
	}
	if (bonusID == 11)
	{
		SBString = "#11: Free super hersir every 30 seconds (if pop available)";
		addSpawningUnit("Hero Norse", 1, 30, 1, 100);
	}
	if (bonusID == 26)
	{
		addSpawningUnit("Portable Ram", 1, 30, 1, 100);
		addSpawningUnit("Petrobolos", 1, 30, 1, 100);
	}

	// Ulfsarks to repair the Hill Fort
	addSpawningUnit("Ulfsark", 1, 10, 0,100);

	// map generation progress
	rmSetStatusText("",0.65);


	///// ISLAND UNITS /////
	addBuyableUnit(5, -2, sMU1, iMU1Cost, 1);
	addBuyableUnit(5, 0.7, sMU2, iMU2Cost, 1);
	addBuyableUnit(5, -0.7, sHero, iHeroCost, 0);


	addRampUnit(15, "Pharaoh", 4.8, 3.4, 2);
	addRampUnit(50, "Hero Norse", 4.7, 4.6, 10);
	addRampUnit(85, "Hero Greek Bellerophon", 4.6, 2.2, 5);
    addRampUnit(85, "Circe", 4.8, 4.6, 5);

	//SUPER ARCHER RAMP UNIT

	if (sArc3 == "Archer Atlantean") {
		 addRampUnit(40, "Toxotes", 4.8, 3.2, 10);
	}
	else {
	     addRampUnit(40, "Archer Atlantean", 4.8, 3.2, 10);
	}


	for(i=1; <cNumberPlayers) {
		if(rmGetPlayerCiv(i)==cCivThor)
			addUniqueUnit(4.8, 1.8, i, "Dwarf", 4);
		else if(rmGetPlayerCiv(i)==cCivOdin)
			addUniqueUnit(4.8, 1.8, i, "Cataphract", 3);
		else if(rmGetPlayerCiv(i)==cCivLoki)
			addUniqueUnit(4.8, 1.8, i, "Maceman", 2);
	}

	// map generation progress
	rmSetStatusText("",0.75);

	addGodPowerUnit(-2, 5, "Arkantos", "Lightning Storm", 34);
	addGodPowerUnit(-0.7, 5, "Amanra", "Sandstorm", 30);
	addGodPowerUnit(0.7, 5, sPower1Caster, sPower1, iPower1Cost);
	addGodPowerUnit(2, 5, sPower2Caster, sPower2, iPower2Cost);

	// map generation progress
	rmSetStatusText("",0.85);

	addTechUnit(-2, -2.8, "Skult", "Weapons", cTechIronWeapons, 19, 35, 1, "Attack +1");
	if (SB_Upgrades == 0)
	{
		addTechUnit(-1, -2.8, "Brokk", "Mail", cTechIronMail, 15, 35, 1, "Hack");
		addTechUnit(1, -2.8, "Eitri", "Shields", cTechIronShields, 15, 35, 1, "Pierce");
	}

	addTechUnit(1.5, -4, "Shaba Ka", "Myth Unit", cTechMonstrousRage, 15, 35, 5, "Myth");
	if (SB_LOS == 0)
		addTechUnit(0.5, -4, "Oracle Hero", "Line of sight", cTechOracle, 13, 35, 12, "LOS");


	addGarrisonUnit(1, "Female", -2, -4, 1);

	addCounterKills();
	addBuildingKills();

	addHelpUnit(3, -4, "Theocrat");


	//bonuses ******

	if (SB_LOS == 0)
	{
		bonusType1="tech"; bonusName1=""+cTechOracle; bonusAmount1=1; bonusDesc1="Line of Sight upgrade";
	}
	else if (SB_LOS == 1)
	{
		bonusType1="tech"; bonusName1=""+cTechThurisazRune; bonusAmount1=1; bonusDesc1="+12%% Myth Unit Speed";
	}

	bonusType2="tech"; bonusName2=""+cTechThurisazRune; bonusAmount2=4; bonusDesc2="+50%% Myth Unit Speed";
	bonusType3="tech"; bonusName3=""+cTechRelicArrowsofAlfar; bonusAmount3=30; bonusDesc3="+60 Building Attack";
	addBonus(100 / SB_KB_MULT, "Caravan Atlantean");


	bonusType1="tech"; bonusName1=""+cTechIronWeapons; bonusAmount1=3; bonusDesc1="3 Weapon Upgrades";
	bonusType2="unit"; bonusName2="Circe"; bonusAmount2=1; bonusDesc2="1 Circe (100 hack & pierce attack)";
	string rewardArcher = "Toxotes"; if(sArc3=="Toxotes") rewardArcher="Archer Atlantean";
	id = rmCreateTrigger("modify_rewardArcher"); rmSwitchToTrigger(id);
      	modifyProtoUnit(rewardArcher, 13, 10);       // rewardArcher projectiles fired
      	modifyProtoUnit(rewardArcher, 12, 8);       // rewardArcher Minamum Range
      	modifyProtoUnit(rewardArcher, 0, 222);       // rewardArcher HP
      	modifyProtoUnit(rewardArcher, 6, -3);       // rewardArcher Pop Cost
      	modifyProtoUnit(rewardArcher, 24, 0.10);       // reward archer hack armour
      	modifyProtoUnit(rewardArcher, 25, 0.15);       // reward archer pierce armour
      	modifyProtoUnit(rewardArcher, 11, 2);       // reward archer range bonus
      	modifyProtoUnit(rewardArcher, 1, 1);       // reward archer Speed bonus
 	modifyProtoUnit(rewardArcher, 31, 12); // reward archer + 12 Attack
 	modifyProtoUnit(rewardArcher, 32, -1); // reward archer -1 Chrush Attack
      	modifyProtoUnit(rewardArcher, 52, -2); // reward archer hillfort handicap
 	modifyProtoUnit(rewardArcher, 50, -2); // reward Archer tower handicap

	bonusType3="unit"; bonusName3=rewardArcher; bonusAmount3=3; bonusDesc3="3 Super Archers";
	addBonus(300 / SB_KB_MULT, "Caravan Greek");

	bonusType1="unit"; bonusName1=sMU2; bonusAmount1=89/iMU2Cost; bonusDesc1=""+bonusAmount1+" "+nMU2;
	bonusType2="tech"; bonusName2=""+cTechBacchanalia; bonusAmount2=6; bonusDesc2="+30%% HP for All Units";
	bonusType3="unit"; bonusName3="Hero Norse"; bonusAmount3=4; bonusDesc3="4 Super Hersirs";
	addBonus(500 / SB_KB_MULT, "Caravan Norse");

	bonusType1="unit"; bonusName1="Hero Greek Bellerophon"; bonusAmount1=2; bonusDesc1="2 Super Bellerophons";
	bonusType2="tech"; bonusName2=""+cTechRelicTailofCerberus; bonusAmount2=3; bonusDesc2="-75%% Myth Unit Recharge";
	bonusType3="unit"; bonusName3="Circe"; bonusAmount3=2; bonusDesc3="2 Circe";
	addBonus(700 / SB_KB_MULT, "Caravan Egyptian");

	bonusType1="unit"; bonusName1="Titan Atlantean"; bonusAmount1=1; bonusDesc1="1 Titan";
	bonusType2="tech"; bonusName2=""+cTechIronWeapons; bonusAmount2=5; bonusDesc2="5 Weapon upgrades";
      bonusType3="unit"; bonusName3=rewardArcher; bonusAmount3=7; bonusDesc3="7 Super Archers";
	addBonus(900 / SB_KB_MULT, "Old Man");

	bonusType1="unit"; bonusName1="Hero Greek Bellerophon"; bonusAmount1=4; bonusDesc1="4 Super Bellerophons";
	bonusType2="tech"; bonusName2=""+cTechIronWeapons; bonusAmount2=8; bonusDesc2="8 Weapon upgrades";
	bonusType3="unit"; bonusName3="Hero Norse"; bonusAmount3=7; bonusDesc3="7 Super Hersirs";
	addBonus(1100 / SB_KB_MULT, "Skult");

	bonusType1="tech"; bonusName1=""+cTechOmniscience; bonusAmount1=1; bonusDesc1="Omniscience";
	bonusType2="tech"; bonusName2=""+cTechBacchanalia; bonusAmount2=14; bonusDesc2="+70%% HP for All Units";
	bonusType3="unit"; bonusName3="Circe"; bonusAmount3=5; bonusDesc3="5 Circe";
	addBonus(1300 / SB_KB_MULT, "Folstag Flag Bearer");

	bonusType1="tech"; bonusName1=""+cTechMonstrousRage; bonusAmount1=10; bonusDesc1="10 Myth Attack Upgrades";
	bonusType2="unit"; bonusName2="Hero Greek Bellerophon"; bonusAmount2=6; bonusDesc2="6 Super Bellerophons";
	bonusType3="unit"; bonusName3="War Elephant"; bonusAmount3=10; bonusDesc3="10 War Elephants";
	addBonus(1500 / SB_KB_MULT, "Mercenary Cavalry");

	bonusType1="unit"; bonusName1="Titan Atlantean"; bonusAmount1=3; bonusDesc1="3 TITANS";
	bonusType2="tech"; bonusName2=""+cTechIronWeapons; bonusAmount2=20; bonusDesc2="20 Weapon upgrades";
	bonusType3="unit"; bonusName3="Hero Greek Polyphemus"; bonusAmount3=2; bonusDesc3="2 MEGA Polyphemus";
	addBonus(1800 / SB_KB_MULT, "Forkboy");

	// map generation progress
	rmSetStatusText("",0.95);



	// author acknowledgement

	id = rmCreateTrigger("author_loop");
	rmSwitchToTrigger(id);
	rmSetTriggerLoop(true);
	newCondition("Timer");
	 condParam("Param1", "600");
	newEffect("Message");
	 effectParam("Timeout", "14000");
	 effectParam("Text", "Norse Wars is a map by Matei Woad Creations."+" You can sign up for the Norse Wars Ladder at www.NorseWars.com.");
         newEffect("Fire Event");
	 effectParam("EventID", "Editor_loop");


	// random battle music triggers


	id = rmCreateTrigger("musicStop_initial");	// stop game music
	rmSwitchToTrigger(id);
	rmSetTriggerRunImmediately(true);
	newEffect("Music Stop");

	id = rmCreateTrigger("musicStop_loop");
	rmSwitchToTrigger(id);
	rmSetTriggerLoop(true);
	rmSetTriggerPriority(5);
	newEffect("FadeOutMusic");
	newEffect("Music Stop");

	i = NUM_MUSICS;
	name1 = "";
	while(true) {
		if(i==0) {
			break;
		}
		else if(i==1) {
			name1 = "\music\culture\of norse not!.mp3";
		}
		else {
			while(true) {
				name2 = chooseRand4(
					chooseRand5("\xpack\xmusic\hotlantis.mp3",
						"\xpack\xcinematics\12_b\music1.mp3",
						"\xpack\xcinematics\8_in\music.mp3",
						"\xpack\xcinematics\7_out\music.mp3",
						"\xpack\xcinematics\10_a\music.mp3"),
					chooseRand5("\music\fight\meatier shower.mp3",
						"\music\fight\oi, that pops!!!.mp3",
						"\music\fight\i wish i could throw shapes.mp3",
						"\music\fight\the fire brigade.mp3",
						"\xpack\xcinematics\7_in\music.mp3"),
					chooseRand5("\music\fight\rot loaf.mp3",
						"\music\fight\li'l drips.mp3",
						"\cinematics\23_out\music 2.mp3",
						"\music\interface\gank sneakin'.mp3",
						"\cinematics\28_in\music.mp3"),
					chooseRand5("\music\fight\rot loaf.mp3",
						"\music\standard\the ballad of ace lebaron.mp3",
						"\cinematics\23_out\music 2.mp3",
						"\music\interface\if you can use a doorknob.mp3",
						"\cinematics\35_in\music3.mp3")
				);
				if(name2 != name1) {
					name1 = name2; break;
				}
				// else continue
			}
		}

		id = rmCreateTrigger("music_"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerPriority(5);
		if(i != 1) {
			rmSetTriggerActive(false);
		}
		if(i != NUM_MUSICS) {
		newEffect("Sound Filename");
		 effectParam("Sound", name1);
		 effectParam("EventID", ""+nextMusicID);
		}

		if(i==2) {
			secondMusicID = id;
		}
		if(i==NUM_MUSICS) {
			lastMusicID = id;
		}

		nextMusicID = id;
		i--;
	}

	// loop back to track 2 when last trigger fires
	rmSwitchToTrigger(lastMusicID);
	newEffect("Fire Event");
	 effectParam("EventID", ""+secondMusicID);

	// map generation progress
	rmSetStatusText("",1.00);

}

